/**
*
* CSoap Service Client Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package EchoClient;

import java.net.MalformedURLException;
import java.net.URL;



public class EchoClient {
	
	
	public void runService(URL url)
	{
		EchoService.EchoPortType service = new EchoService.EchoBindingStub(url,null);
		try
		{
			String  result = service.echoString("Hello");
			System.out.println("Sent 'Hello' , got '"+result+"'");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	
	public static void main(String[] args)
	{
		EchoClient app = new EchoClient();
		if (args!=null && args.length>0 && args[0].equals("--help")) 
	    {
		System.out.println("The EchoClient class allows you to run the Web Service Echo by giving its endpoint URL");
		System.out.println("[Usage]: java EchoClient serviceURL ");
		return;
	    }
		
		if (args==null || args.length==0)
		{
			System.out.println("service URL is missed");
			return;
		}
		
		if (args==null || args.length>1)
		{
			System.out.println("Too match parameters, use --help to see more detail");
			return;
		}
		String serviceEndPoint = args[0];
		try
		{
			URL url =new URL(serviceEndPoint);
			app.runService(url);
		}
		catch(MalformedURLException ex)
		{
			System.out.println("Malformed URL "+serviceEndPoint);
			return;
		}
		
        	
	}

}
