/**
*
* CSoap Service Client Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package EchoClient;

import javax.xml.rpc.Call;
import javax.xml.namespace.QName;


public class SimpleEchoClient {
	public static void main(String [] args) {
		  try {
		      String endpoint = "http://localhost:8080/csoap/Echo";
		 
		      Call  call = (Call) new csoap.xml.rpc.CallImpl();
		 
		     call.setTargetEndpointAddress(endpoint);
		     call.setOperationName(new QName("urn:EchoService", "echoString"));
		     call.setReturnType(new QName("http://www.w3.org/2001/XMLSchema", 
		                        "string"));
		     call.addParameter("param",                         
		                        javax.xml.rpc.encoding.XMLType.XSD_STRING,
		                        javax.xml.rpc.ParameterMode.IN);
		
		     String ret = (String) call.invoke( new Object[] { "Hello!" } );
		  
		     System.out.println("Sent 'Hello!', got '" + ret + "'");
		   } catch (Exception e) {
		    System.err.println(e.toString());
		   }
		  }
}
