/**
*
* CSoap Service Client Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package RFIDMusicClient;

import java.net.MalformedURLException;
import java.net.URL;



public class RFIDMusicClient {
	
	
	public void runService(URL url)
	{
		RFIDMusicService.RFIDMusicPortType service = new RFIDMusicService.RFIDMusicBindingStub(url,null);
		try
		{
			String  result = service.getInfo("4-010165-314153");
			System.out.println("result = "+result);
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	
	public static void main(String[] args)
	{
		RFIDMusicClient app = new RFIDMusicClient();
		if (args!=null && args.length>0 && args[0].equals("--help")) 
	    {
		System.out.println("The RFIDMusicClient class allows you to run the Web Service RFIDMusic by giving its endpoint URL");
		System.out.println("[Usage]: java RFIDMusicClient serviceURL ");
		return;
	    }
		
		if (args==null || args.length==0)
		{
			System.out.println("service URL is missed");
			return;
		}
		
		if (args==null || args.length>1)
		{
			System.out.println("Too match parameters, use --help to see more detail");
			return;
		}
		String serviceEndPoint = args[0];
		try
		{
			URL url =new URL(serviceEndPoint);
			app.runService(url);
		}
		catch(MalformedURLException ex)
		{
			System.out.println("Malformed URL "+serviceEndPoint);
			return;
		}
		
        	
	}

}
