/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class CSoapServlet extends HttpServlet  
{
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
      response.setContentType("text/html");
      String URI = request.getRequestURI();
      if (URI.equals("/csoap/AdminClient"))
	  {
    	  PrintWriter out = response.getWriter();
	      int result = GlobalManagingServer.receiveWsdd(request);
	      switch (result) {
	      case -1:
		  out.write("Cannot deploy your Service");
		  break;
	      case 0:
		  out.write("Your Service is deployed");
		  break;
	      case 1:
		  out.write("Your Service is already deployed");
		  break;
	      case 2:
			  out.write("Your Service is undeployed");
			  break;
	      case 3:
			  out.write("Your Service is not deployed");
			  break;
	      }
	  }
      else
	  {
    	  String serviceName = URI.substring(URI.lastIndexOf("/")+1);
	      if (serviceName.toLowerCase().equals("firsttest")) 
	      {
	    	  PrintWriter out = response.getWriter();
	    	  out.write("<html><head></head><body><center><p><font size=25 color=blue>CSOAP Server</font></p><p aligne=center>CSOAP installed successfully</p><p aligne=center>Feedback : rafik.chibout@inria.fr</p></center></body></html>");
	      }
	      else GlobalManagingServer.receiveSOAP(URI, serviceName, request, response);
	  }
      
    }

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
		response.setContentType("text/html");
		String URI = request.getRequestURI();
		if (URI.equals("/csoap/AdminClient"))
	    {
			PrintWriter out = response.getWriter();
			int result = GlobalManagingServer.receiveWsdd(request);
			switch (result) 
			{
				case -1:
					out.write("Can't deploy your Service");
					break;
				case 0:
					out.write("Your Service is deployed");
					break;
				case 1:
					out.write("Your Service is already deployed");
					break;
				case 2:
					  out.write("Your Service is undeployed");
					  break;
			    case 3:
					  out.write("Your Service is not deployed");
					  break;
			}
	    }
		else
	    {
			String serviceName = URI.substring(URI.lastIndexOf("/")+1);
			if (serviceName.toLowerCase().equals("firsttest")) 
			{
				PrintWriter out = response.getWriter();
				out.write("<html><head></head><body><center><p><font size=25 color=blue>CSOAP Server</font></p><p aligne=center>CSOAP installed successfully</p><p aligne=center>Feedback : rafik.chibout@inria.fr</p></center></body></html>");
			}
			else GlobalManagingServer.receiveSOAP(URI, serviceName, request, response);
	    }
    }
	
    public void destroy()
    {
    	GlobalManagingServer.destroy();
    }

}
