/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap;

import java.io.*;
import csoap.server.*;
import javax.servlet.http.*;
import csoap.util.*;

public class GlobalManagingServer extends GlobalManaging
{

static ProviderManager providerManager = new ProviderManager();

   
   	public static int receiveWsdd(HttpServletRequest request)
   	{
      try
	  {          
	      InputStream is = request.getInputStream();
	      return objectDeployment.deploy(is,objectServices);
	  }
      catch (Exception ex)
	  {
	      System.out.println("Cannot create InputStream from WSDD");
	  }
      return -1;
    }
    
    public static void receiveSOAP(String URI, String serviceName,HttpServletRequest request, HttpServletResponse response) 
    {
    	log.setLevelDebug(log.LEVEL_LOW);
    	callWebService callWS = new callWebService(typeMappingRegistry, handlerRegistry,providerManager);
        callWS.invoke(URI, serviceName, objectServices, request, response);
    }
   
    public static void destroy()
    {
    	providerManager.destroy();
    	providerManager=null;
    }   
  
}
