/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.deployment;

import java.net.HttpURLConnection;
import java.net.URL;

public class HTTPSender {

	public static String sendMessage(String message , String endPoint)
	{
		try {
			
			URL url = new java.net.URL(endPoint.toString());
			java.net.HttpURLConnection urlConn = (java.net.HttpURLConnection)url.openConnection();
			urlConn.setDoInput (true);
			urlConn.setDoOutput (true);
			urlConn.setUseCaches (false);
			urlConn.setRequestProperty("User-Agent", "Profile/MIDP-1.0 Configuration/CLDC-1.0");
			urlConn.setRequestProperty("Content-Language", "en-US");
			urlConn.setRequestProperty("content-Type", "application/x-www-form-urlencoded");
			       
			java.io.OutputStream os = urlConn.getOutputStream();
			java.io.OutputStreamWriter writer = new  java.io.OutputStreamWriter(os);
			
			writer.write(message);
			
			writer.flush();
			while (urlConn.getResponseCode() != HttpURLConnection.HTTP_OK){}   
		  	
			java.io.InputStream is = urlConn.getInputStream();
			java.io.InputStreamReader reader = new  java.io.InputStreamReader(is);
			
			StringBuffer response = new StringBuffer();
			int num = 0;
			
			while (num >=0 || reader.ready())
				{
					char[] buff = new char[1024];
					num = reader.read(buff);
					if (num > 0) response.append(buff,0, num);
				}
						
			writer.close();
			os.close();
			reader.close();
			is.close();
			urlConn.disconnect();
			return response.toString();
		   }
		   catch (Exception ex) {
		       ex.printStackTrace();
		   }
		   return null;
	}
	
}
