/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.deployment;

import javax.xml.namespace.QName;
import java.util.Vector;
import java.util.Iterator;

public class Operation {

    String name;
    QName qname;
    QName returnQName;
    QName returnType;
  
    private Vector parameters = new Vector();

    public Operation(String Name, QName Qname, QName ReturnQName, QName ReturnType) {
        name = Name;
        qname = Qname;
        returnQName = ReturnQName;
        returnType = ReturnType;
    }
    
    public Operation(String Name, QName Qname) {
        name = Name;
        qname = Qname;
    }

    public void setReturnQName(QName ReturnQName) {
        returnQName = ReturnQName;
    }

    public void setReturnType(QName ReturnType) {
        returnType = ReturnType;
    }

    public void setQName(QName Qname) {
        qname = Qname;
    }

    public void setName(String Name) {
        name = Name;
    }

    public QName getQName() {
        return qname ;
    }
 
    public QName getReturnQName() {
        return returnQName ;
    }
    
    public QName getReturnType() {
        return returnType ;
    }

    public String getName() {
        return name;
    }

    public void addParameter(String Name, QName Qname, String Mode) {
        parameterOperation param = new parameterOperation(Name, Qname, Mode);
        parameters.addElement(param);
    }

    public void addParameter(String Name, String Qname, String uri,  String Mode) {
        parameterOperation param = new parameterOperation(Name, Qname, uri , Mode);
        parameters.addElement(param);
    }

    public Iterator getParameters() {
        return parameters.iterator();
    }

    public int getNParameters() {
        return parameters.size();
    }
}