/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.deployment;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class WSDDSender {

	
	public static void main(String[] args)
	{
		if (args!=null && args.length>0 && args[0].equals("--help")) 
	    {
		System.out.println("The WSDDSender class allows you to deploy a Web Service by giving its csoap wsdd file");
		System.out.println("[Usage]: java WSDDSender [-options] wsddfile ");
		return;
	    }
		
		if (args==null || args.length==0)
		{
			System.out.println("csoap wsdd file of service is missed");
			return;
		}
		
		if (args==null || args.length>1)
		{
			System.out.println("Too match parameters, use --help to see more detail");
			return;
		}
		
		String wsddFile = "";
		try
		{
			FileInputStream file = new FileInputStream(args[0]);
			int num = 0;
			while (num !=-1)
			{
				byte[] buff = new byte[1000];
				num = file.read(buff);
				if (num>0) wsddFile = wsddFile+(new String(buff,0,num));
			}
		}
		catch(FileNotFoundException ex)
		{
			System.out.println("File not found : "+args[0]);
			return;
		}
		catch(IOException ex)
		{
			System.out.println("Error in reading file : "+args[0]);
			return;
		}
		
		String result = HTTPSender.sendMessage(wsddFile, "http://localhost:8080/csoap/AdminClient");
		System.out.println(result);
		
	}
	
}
