/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.server;

import java.util.Vector;
import java.util.Iterator;
import csoap.xml.soap.*;
import javax.xml.soap.*;
import javax.xml.namespace.QName;
import csoap.xml.rpc.encoding.*;
import javax.xml.rpc.encoding.*;
import java.io.*;
import java.lang.reflect.*;
import java.util.List;
import javax.xml.rpc.handler.*;
import javax.xml.rpc.handler.soap.SOAPMessageContext;
import csoap.xml.rpc.handler.soap.SOAPMessageContextImpl;
import csoap.deployment.*;
import javax.servlet.http.*;

public class callWebService {
    QName xmlTypeReturn, operationName, portType;
    boolean methodHasReturn = false;
    String className="";
    Class returnJAVAType;
    Service service;
    Vector parametersName = new Vector(30);
    Vector parametersXMLType = new Vector(30);
    Class parametersJAVAType[] ; 
    Object parametersValue[] ;
    Vector parametersMode = new Vector(30);
    Iterator childs;
    Object result = null;
    
    MessageFactoryImpl factory = new MessageFactoryImpl();
    static TypeMappingRegistryImpl typeRegistry;
    static TypeMapping typeMapping;
    static ProviderManager providerManager;
    DeserializerFactory deserializerFactory;
    SerializerFactory serializerFactory;
    DeserializerBase deserializer;
    SerializerBase serializer;
    HandlerRegistry handlerRegistry;
    
    RPCProvider provider;
    
    Mapping mapping = new Mapping();
    
  
  public callWebService(TypeMappingRegistry TypeRegistry, HandlerRegistry hAndlerRegistry, ProviderManager pRoviderManager)
  {
    handlerRegistry = hAndlerRegistry;
    typeRegistry = (TypeMappingRegistryImpl)TypeRegistry;
    providerManager = pRoviderManager;
  }

 /*
  *   URI parameter added for CoreBroker Customization compatibility
  */
    
    /// Class Holder Manager

    private Class getJavaTypeHolder(String XMLDataType, String namespace) 
    {
	
	Class ret=null;
	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String soapNameSpace="http://schemas.xmlsoap.org/soap/encoding/";
	
	//case XML Schema type)
	if ((namespace.equals(schemaNameSpace1999))||
	    (namespace.equals(schemaNameSpace2000))||
	    (namespace.equals(schemaNameSpace2001))) {
		if (XMLDataType.equals("string")) ret=javax.xml.rpc.holders.StringHolder.class;
		else if (XMLDataType.equals("integer")) ret=javax.xml.rpc.holders.BigIntegerHolder.class;
		else if (XMLDataType.equals("int")) ret=javax.xml.rpc.holders.IntHolder.class;
		else if (XMLDataType.equals("short")) ret=javax.xml.rpc.holders.ShortHolder.class;
		else if (XMLDataType.equals("decimal")) ret=javax.xml.rpc.holders.BigDecimalHolder.class;

		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret=javax.xml.rpc.holders.BigDecimalHolder.class;
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret=javax.xml.rpc.holders.DoubleHolder.class;
		 
		else if (XMLDataType.equals("float")) ret=javax.xml.rpc.holders.FloatHolder.class;
		else if (XMLDataType.equals("double")) ret=javax.xml.rpc.holders.DoubleHolder.class;
		else if (XMLDataType.equals("boolean")) ret=javax.xml.rpc.holders.BooleanHolder.class;
		else if (XMLDataType.equals("byte")) ret=javax.xml.rpc.holders.ByteHolder.class;
		else if (XMLDataType.equals("QName")) ret=javax.xml.rpc.holders.QNameHolder.class;
		else if (XMLDataType.equals("DateTime")) ret=javax.xml.rpc.holders.CalendarHolder.class;
		else if (XMLDataType.equals("base64Binary")) ret=javax.xml.rpc.holders.ByteArrayHolder.class;
		else if (XMLDataType.equals("hexBinary")) ret=javax.xml.rpc.holders.ByteArrayHolder.class;
	}
	else if (namespace==soapNameSpace) {
		if (XMLDataType.equals("string")) ret=javax.xml.rpc.holders.StringHolder.class;
		else if (XMLDataType.equals("boolean")) ret=javax.xml.rpc.holders.BooleanWrapperHolder.class;
		else if (XMLDataType.equals("float")) ret=javax.xml.rpc.holders.FloatWrapperHolder.class;
		else if (XMLDataType.equals("double")) ret=javax.xml.rpc.holders.DoubleWrapperHolder.class;
		else if (XMLDataType.equals("decimal")) ret=javax.xml.rpc.holders.BigDecimalHolder.class;
		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret=java.xml.rpc.holders.BigDecimalHolder.class;
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret=java.xml.rpc.holders.DoubleHolder.class;
		
		else if (XMLDataType.equals("int")) ret=javax.xml.rpc.holders.IntegerWrapperHolder.class;
		else if (XMLDataType.equals("short")) ret=javax.xml.rpc.holders.ShortWrapperHolder.class;
		else if (XMLDataType.equals("byte")) ret=javax.xml.rpc.holders.ByteWrapperHolder.class;
		//else if (XMLDataType.equals("base64")) ret="Java.xml.rpc.holders. ";
	}
	
	return ret;
 }


    // object Holder manager

   private Object getObjectHolder(String XMLDataType, String namespace, Object obj) 
    {
	Object ret =null;
	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String soapNameSpace="http://schemas.xmlsoap.org/soap/encoding/";
	
	//case XML Schema type)
	if ((namespace.equals(schemaNameSpace1999))||
	    (namespace.equals(schemaNameSpace2000))||
	    (namespace.equals(schemaNameSpace2001))) {
	    if (XMLDataType.equals("string")) ret= new javax.xml.rpc.holders.StringHolder(obj.toString());
		else if (XMLDataType.equals("integer")) ret= new javax.xml.rpc.holders.BigIntegerHolder((java.math.BigInteger)obj);
		else if (XMLDataType.equals("int")) ret= new javax.xml.rpc.holders.IntHolder(((java.lang.Integer)obj).intValue());
		else if (XMLDataType.equals("short")) ret= new javax.xml.rpc.holders.ShortHolder((new java.lang.Short(obj.toString())).shortValue());
		else if (XMLDataType.equals("decimal")) ret= new javax.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));

		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret= new javax.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret= new javax.xml.rpc.holders.DoubleHolder((new java.lang.Double(obj.toString())).doubleValue());
		 
		else if (XMLDataType.equals("float")) ret= new javax.xml.rpc.holders.FloatHolder((new java.lang.Float(obj.toString())).floatValue());
		else if (XMLDataType.equals("double")) ret= new javax.xml.rpc.holders.DoubleHolder((new java.lang.Double(obj.toString())).doubleValue());
		else if (XMLDataType.equals("boolean")) ret= new javax.xml.rpc.holders.BooleanHolder((new java.lang.Boolean(obj.toString())).booleanValue());
		else if (XMLDataType.equals("byte")) ret= new javax.xml.rpc.holders.ByteHolder((new java.lang.Byte(obj.toString())).byteValue());
		else if (XMLDataType.equals("QName")) ret= new javax.xml.rpc.holders.QNameHolder((QName)obj);
		else if (XMLDataType.equals("DateTime")) ret= new javax.xml.rpc.holders.CalendarHolder((java.util.Calendar)obj);
		else if (XMLDataType.equals("base64Binary")) ret= new javax.xml.rpc.holders.ByteArrayHolder((byte[])obj);
		else if (XMLDataType.equals("hexBinary")) ret= new javax.xml.rpc.holders.ByteArrayHolder((byte[])obj);
	}
	else if (namespace==soapNameSpace) {
		if (XMLDataType.equals("string")) ret= new javax.xml.rpc.holders.StringHolder(obj.toString());
		else if (XMLDataType.equals("boolean")) ret= new javax.xml.rpc.holders.BooleanWrapperHolder(new java.lang.Boolean(obj.toString()));
		else if (XMLDataType.equals("float")) ret= new javax.xml.rpc.holders.FloatWrapperHolder(new java.lang.Float(obj.toString()));
		else if (XMLDataType.equals("double")) ret= new javax.xml.rpc.holders.DoubleWrapperHolder(new java.lang.Double(obj.toString()));
		else if (XMLDataType.equals("decimal")) ret= new javax.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));
		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret= new java.xml.rpc.holders.BigDecimalHolder(new java.math.BigDecimal(obj.toString()));
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret= new java.xml.rpc.holders.DoubleWrapperHolder(new java.lang.Double(obj.toString()));
		
		else if (XMLDataType.equals("int")) ret= new javax.xml.rpc.holders.IntegerWrapperHolder(new java.lang.Integer(obj.toString()));
		else if (XMLDataType.equals("short")) ret= new javax.xml.rpc.holders.ShortWrapperHolder(new java.lang.Short(obj.toString()));
		else if (XMLDataType.equals("byte")) ret= new javax.xml.rpc.holders.ByteWrapperHolder((java.lang.Byte)obj);
		//else if (XMLDataType.equals("base64")) ret= new javax.xml.rpc.holders. ";
	}
	
	 
	return ret;

  }

  public String getClassHolderName(String ClassXMLName, String packageName)
  {
	String firstCar = ClassXMLName.substring(0,1);
	firstCar.toUpperCase();
	String withoutFirstCar = ClassXMLName.substring(1);
	ClassXMLName = firstCar+withoutFirstCar;
	try
	    {
		Class myClass = Class.forName(packageName+".holders."+ClassXMLName+"Holder");
	    }
	catch(Exception ex)
	    {
		System.out.println("Error in instance of "+ packageName+".holders."+ClassXMLName+"Holder");
	    }
	return packageName+".holders."+ClassXMLName+"Holder";
    }
    

   /// Invoke

  public void invoke(String URI, String serviceName, deployedServices objectServices, HttpServletRequest request, HttpServletResponse response) 
  {
	 methodHasReturn = false;
     OutputStream os = null;
     InputStream  is = null; 
     javax.xml.rpc.soap.SOAPFaultException SOAPException = null;
     try
	 {
	     is =request.getInputStream();
	 }
     catch (Exception ex)
	 {
	     System.out.println("Error in create Output and Input Stream");
	 }
     
     service = objectServices.getService(serviceName);
     if (service == null) 
     {
    	 System.out.println("Service "+serviceName+" is not deployed in this CSoap Server");
    	 // return a fault message
    	 SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "SOAP Service unknow", serviceName, null);
    	 return;
     }
     
     Operation operation =  null;
     String method = null;
     int nParams = 0;
     Object obj =null;
     int i = 0;
     Iterator params = null;

     Cookie[] cookies_client = request.getCookies();
     String client_id ="";
     if (cookies_client != null)
	 {
	     for (i=0;i<cookies_client.length;i++)
		 { 
		     Cookie cook = cookies_client[i];
		     if (cook.getName().equals("id")) client_id = cook.getValue();
		 }
	 }
     
     String type="", prefix="";
     SOAPMessageImpl sOAPMessage = null;
     boolean bool = true;
     
     try
	 {
	    sOAPMessage = (SOAPMessageImpl)factory.createMessage(null, is);
	 }
     catch (Exception ex)
	 {
	     bool = false;
	     SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "Message SOAP incorrectly formed", service.getServiceName(), null);
	 }
     if (bool)
	 {

	     SOAPMessageContext sOAPMessageContext = new SOAPMessageContextImpl();
	     sOAPMessageContext.setMessage(sOAPMessage);
	     sOAPMessageContext.setProperty("transport.url", URI);
	     
	     /// Handlerchain  for All
	     HandlerChain handlerChain;
	     List list = handlerRegistry.getHandlerChain(QName.valueOf("*"));
	     
	     if (list != null) {
		 for (i=0; i<list.size();i++)   {
		     handlerChain = (HandlerChain)list.get(i);
		     handlerChain.handleRequest(sOAPMessageContext);    
		 }
	     }
  	     /// Handlerchain for service
	     list = handlerRegistry.getHandlerChain(QName.valueOf(serviceName));
	     if (list != null) {
		 for (i=0; i<list.size();i++) 
		     {
			 handlerChain = (HandlerChain)list.get(i);
			 handlerChain.handleRequest(sOAPMessageContext);
		     }
	     }
	     try
		 {
		     SOAPPartImpl sOAPPart = (SOAPPartImpl)sOAPMessage.getSOAPPart();
		     SOAPEnvelopeImpl sOAPEnvelope = (SOAPEnvelopeImpl) sOAPPart.getEnvelope();
		     SOAPBodyImpl sOAPBoby = (SOAPBodyImpl) sOAPEnvelope.getBody();
		     childs = sOAPBoby.getChildElements();
		     SOAPBodyElementImpl sOAPBodyElement = null;
		     SOAPElement sOAPElement = null;
		     if (childs.hasNext()) 
			 sOAPBodyElement = (SOAPBodyElementImpl)childs.next();
		     operationName = QName.valueOf("{"+sOAPBodyElement.getElementName().getURI()+"}"+sOAPBodyElement.getElementName().getLocalName());
		     operation = service.getOperation(operationName);
		     method = operation.getName();

		     if (operation.getReturnType()!=null && !operation.getReturnType().equals("")) methodHasReturn = true;

		     className = service.getParameterValue("className");

		     nParams = operation.getNParameters();

		     parametersJAVAType = new Class[nParams];
		     parametersValue = new Object[nParams];
		     i = 0;
		     params = operation.getParameters();
		     if (!methodHasReturn)
			 {
			     // are there parameter with OUT or INOUT mode?
			     while (params.hasNext() && !methodHasReturn )
				 {
				     parameterOperation paramTemp = (parameterOperation)params.next();
				     if (paramTemp.getMode().equals("OUT") || paramTemp.getMode().equals("INOUT")) methodHasReturn = true;
				 }
			     params = operation.getParameters();
			 }
		     // if oneWay (methodHasReturn=false), return a HTTP ok message
		     if (!methodHasReturn)
			 {
			     PrintWriter out = response.getWriter();
			     out.write("ok");
			     out.close();
			 }

		     childs = sOAPBodyElement.getChildElements();
 		     // new add
		     while (params.hasNext()) 
			 {    
			     obj = null; 
			     parameterOperation param = (parameterOperation)params.next();
			     if ( !param.getMode().equals("OUT"))  
				 {
				     if (childs.hasNext()) 
				     sOAPElement = (SOAPElement)childs.next();
				     else System.out.println("Number of parameter error");
				     sOAPElement = Reference.getSOAPElementForDeserialiser(sOAPElement);
				     type = sOAPElement.getAttributeValue(new NameImpl("type"));
				     prefix ="";
				     if (type.indexOf(":") != -1 )
					 {
					     prefix = type.substring(0,type.indexOf(":"));
					     type = type.substring(type.indexOf(":")+1);
					 }
				     QName xmlType = QName.valueOf("{"+sOAPElement.getNamespaceURI(prefix)+"}"+type);
				     typeMapping = typeRegistry.getTypeMapping(xmlType.getNamespaceURI());   
				     deserializerFactory = typeMapping.getDeserializer(null,xmlType);   
				     deserializer = (DeserializerBase)deserializerFactory.getDeserializerAs("default");
				      
				     obj = deserializer.deserialize(sOAPElement,typeRegistry,service);   
				     if (param.getMode().equals("INOUT"))
					 {
					     javax.xml.rpc.holders.Holder obj2; ; 
					     if (obj != null) 
						 {
						     obj2 = (javax.xml.rpc.holders.Holder)getObjectHolder(param.getQName().getLocalPart(), param.getQName().getNamespaceURI(), obj);
						     if (obj2 == null) 
							 {
							     String packageName = className.substring(0,className.lastIndexOf("."));
							     String XMLTypeParam = param.getQName().getLocalPart();
							     Class objectClass = Class.forName(getClassHolderName(XMLTypeParam, packageName));
							     obj2 = (javax.xml.rpc.holders.Holder)objectClass.newInstance();
						     
							     Field valueField = objectClass.getField("value"); 
							     valueField.set(obj2, obj); 
							     //obj2.value = obj; 
							     
							 }
						     obj = obj2;   
						 }
					     else
						 {
						     //cas when obj = null (xsi:nil=true) or param out omited
						     Class objClass = getJavaTypeHolder(param.getQName().getLocalPart(),param.getQName().getNamespaceURI());
						     if (objClass != null) obj = objClass.newInstance();
						     else
							 {
							     String packageName = className.substring(0,className.lastIndexOf("."));
							     String XMLTypeParam = param.getQName().getLocalPart();
							     Class objectClass = Class.forName(getClassHolderName(XMLTypeParam, packageName));
							     obj = (javax.xml.rpc.holders.Holder)objectClass.newInstance();
							 }
						 }
					     

					 }

				 }			 		     
			     if (param.getMode().equals("OUT"))
				 {
				     //cas when obj = null (xsi:nil=true) or param out omited  
				     Class objClass = getJavaTypeHolder(param.getQName().getLocalPart(),param.getQName().getNamespaceURI());

				     if (objClass != null) obj = objClass.newInstance();
				     else
					 {
					     String packageName = className.substring(0,className.lastIndexOf("."));
					     String XMLTypeParam = param.getQName().getLocalPart();
					     
					     Class objectClass = Class.forName(getClassHolderName(XMLTypeParam, packageName));

					     obj = (javax.xml.rpc.holders.Holder)objectClass.newInstance();
					 }
				 }
			     
			     if (obj != null) 
				 {
				     parametersJAVAType[i] =  typeRegistry.getJavaClass(param.getQName()); 

 				     if (parametersJAVAType[i] == null || !param.getMode().equals("IN")) parametersJAVAType[i] = obj.getClass(); 
				 }
			     else parametersJAVAType[i] =  typeRegistry.getJavaClass(param.getQName()); 
			     parametersValue[i] = obj;
			     i++;
			     	     
			 }
		     
		 }
	     catch (Exception ex)
		 {
		     ex.printStackTrace();
		     bool = false;
		     SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "SOAP Message unknow", service.getServiceName(), null);
		 }
	     
	     
	     /*
	      *  sOAPMessageContext has been added for core broker and axis compatibility
	      *
      */
     
	     // find provider for this client id
 	     if (bool)
		 {
		     javax.xml.rpc.holders.StringHolder client_idHolder = new javax.xml.rpc.holders.StringHolder();
		     client_idHolder.value=client_id;
		     provider = providerManager.getProvider(service,client_idHolder);
		     client_id=client_idHolder.value;

		     Cookie cook2 = new Cookie("id", client_id);
		     response.addCookie(cook2);
		     
		     try
			 {
			     result = provider.runService(sOAPMessageContext, className,method,parametersJAVAType,parametersValue, service);
			 }
		     catch (Exception ex)
			 {
			     bool = false;
			     SOAPException = new javax.xml.rpc.soap.SOAPFaultException(QName.valueOf("Client"), "Execution service error", service.getServiceName(), null);
			 }     
		     
		 }
	 }
     
     if (methodHasReturn)
	 {
     sOAPMessage = new SOAPMessageImpl();
     SOAPPartImpl sOAPPartR = (SOAPPartImpl)sOAPMessage.getSOAPPart();
     SOAPEnvelopeImpl sOAPEnvelopeR = (SOAPEnvelopeImpl)sOAPPartR.getEnvelope();
     sOAPEnvelopeR.createName("Envelope","SOAP-ENV","http://schemas.xmlsoap.org/soap/envelope/");
     sOAPEnvelopeR.setEncodingStyle("http://schemas.xmlsoap.org/soap/encoding/");
     sOAPEnvelopeR.addNamespaceDeclaration("xsi","http://www.w3.org/1999/XMLSchema-instance");
     
     SOAPBodyImpl sOAPBobyR = (SOAPBodyImpl)sOAPEnvelopeR.getBody();
     if (bool)
	 {
	     SOAPBodyElementImpl sOAPBodyElementR = (SOAPBodyElementImpl)sOAPBobyR.addBodyElement(new NameImpl(operationName.getLocalPart()+"Response","ns",operationName.getNamespaceURI()));
	     if (operation.getReturnType() != null)
		 {  
		     typeMapping = typeRegistry.getTypeMapping(operation.getReturnType().getNamespaceURI());     
		     serializerFactory = typeMapping.getSerializer(null, operation.getReturnType());
		     serializer = (SerializerBase) serializerFactory.getSerializerAs("default");
		     sOAPBodyElementR.addChildElement((SOAPElementImpl)serializer.serialize(result,new NameImpl(operationName.getLocalPart()+"Result","ns",operationName.getNamespaceURI()),sOAPBodyElementR,typeRegistry));
		 }
	     //  Serialize the OUTPUT Parameters
	     params = operation.getParameters();
	     
	     int i2 = 0;
	     while (params.hasNext())
	       {
		   parameterOperation param = (parameterOperation)params.next();
		   if (!param.getMode().equals("IN"))
		       {
			  // without convertion 14h29 2003-10-14
			   sOAPBodyElementR.addNamespaceDeclaration("ns"+(i2+1),param.getQName().getNamespaceURI());
			   if (parametersValue[i2] != null)
			       {
				   try
				       {
					   Field valueField = parametersValue[i2].getClass().getField("value"); 
					  if (valueField != null) parametersValue[i2] = valueField.get(parametersValue[i2]); 
				       }
				   catch(Exception ex)
				       {
					   System.out.println("Error in Class Holder value");
				       }
			       }
			   typeMapping = typeRegistry.getTypeMapping(param.getQName().getNamespaceURI());
			   serializerFactory = typeMapping.getSerializer(null, param.getQName());
			   serializer = (SerializerBase) serializerFactory.getSerializerAs("default");
			   sOAPBodyElementR.addChildElement((SOAPElementImpl) serializer.serialize(parametersValue[i2],new NameImpl(param.getName()), sOAPBodyElementR, typeRegistry));
		       }
		   i2++;
	       }
       }
     // end if (bool == true)
     else // bool = true Excpetion traitment
	 {
	     SOAPFaultImpl sOAPFault = (SOAPFaultImpl)sOAPBobyR.addFault();
	     sOAPFault.setFaultActor(SOAPException.getFaultActor());
	     sOAPFault.setFaultCode(SOAPException.getFaultCode().toString());
	     sOAPFault.setFaultString(SOAPException.getFaultString());
	 }
   
     sOAPMessage.saveChanges();
     SOAPMessageContext sOAPMessageContextR = new SOAPMessageContextImpl();
     sOAPMessageContextR.setMessage(sOAPMessage);
     sOAPMessageContextR.setProperty("transport.url", URI);
     
     /// Handlerchain  for All
     
     List list = handlerRegistry.getHandlerChain(QName.valueOf(serviceName));
     if (list != null)
	 for (i=0; i<list.size();i++) {
	     HandlerChain handlerChain = (HandlerChain)list.get(i);
	     handlerChain.handleResponse(sOAPMessageContextR);
	     handlerChain.destroy();
	 }
     /// Handlerchain for service
     list = handlerRegistry.getHandlerChain(QName.valueOf("*"));
     if (list != null)
	 for (i=0; i<list.size();i++) {
	     HandlerChain handlerChain = (HandlerChain)list.get(i);
	     handlerChain.handleResponse(sOAPMessageContextR);
	 }
     
     try
	 {
	     os = response.getOutputStream();
	     System.gc();
	     sOAPMessage.writeTo(os);
	     os.close();
	 }
     catch (Exception ex)
	 {
	     System.out.println("Error in sending response");
	 }
	 }
   
    }
  
}
		    
