package csoap.wsdl;

import javax.xml.namespace.QName;
import java.util.HashMap;
import java.util.Map;

/**
*
* TypeDesc.java
*
* @author Mirco Musolesi
* @author Rafik CHIBOUT
* @version 0.1 July 2003
*  
* This class is modelled according the org.apache.axis.description.TypeDesc Axis class written
* by Glen Daniels.
*  
*/
public class TypeDesc {
	
private ElementDesc[] fields;
private Class javaClass;
private QName xmlType;


/**
* Constructor
*/
public TypeDesc(Class javaClass) {
	this.javaClass=javaClass;
}



/**
* Obtains the current array of ElementDescs
*/
    public ElementDesc[] getFieldEs() {
	return fields;
}

    public ElementDesc getFieldE(String fieldName)
    {
	for (int i=0; i<fields.length; i++)
	    {
		if (fields[i].getFieldName().equals(fieldName)) return fields[i]; 
	    }
	return null;
    }

/**
* Add a new FieldDesc
*/
public void addFieldDesc(ElementDesc field)
{
	int numFields=0;
	if (fields!=null) {
		numFields=fields.length;
	}
	ElementDesc[] newFields=new ElementDesc[numFields+1];
	if (fields!=null) {
		System.arraycopy(fields,0,newFields,0,numFields);
	}
	newFields[numFields]=field;
	fields=newFields;
}

/**
* Obtains XmlType
*/
public QName getXmlType() {
	return xmlType;
}


/**
* Sets XmlType
*/
public void setXmlType(QName xmlType) {
	this.xmlType=xmlType;
}


}//end class


	
