/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;

import csoap.xml.soap.*;
import javax.xml.namespace.QName;

public class DeserializerBase64 implements DeserializerBase
{
    String mechanismType="default";
    Class JAVAClass = byte[].class;
    QName XMLType = javax.xml.rpc.encoding.XMLType.XSD_BASE64;

    public DeserializerBase64(Class JavaClass, QName XmlType)
    {
	JAVAClass = JavaClass;
	XMLType = XmlType;
    }
    

  public Object deserialize(javax.xml.soap.SOAPElement soAPElement, javax.xml.rpc.encoding.TypeMappingRegistry typeMappingRegistry, csoap.deployment.Service service)
  {
    
       String isnull = (String)soAPElement.getAttributeValue(new NameImpl("nil"));
       if (isnull.equals("true")) return null;
       return Base64.decode(soAPElement.getValue());
  }

  public void setMechanismType(String MechanismType)
  {
    mechanismType = MechanismType;
  }
  public String getMechanismType()
  {
    return mechanismType;
  }



}
