/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;

import javax.xml.rpc.encoding.*;
import java.util.*;
import javax.xml.namespace.QName;

public class DeserializerSimpleTypeFactory implements DeserializerFactory{

	Vector deserializers = new Vector();
	Vector mechanismTypes = new Vector();

	public DeserializerSimpleTypeFactory(Class JavaClass,  QName XmlType)
	{
		this.addDeserializer(new DeserializerSimpleType(JavaClass, XmlType));
	}

	public Deserializer getDeserializerAs(String mechanismType)
	{
		return (Deserializer)deserializers.elementAt(mechanismTypes.indexOf(mechanismType));
	}

	public Iterator getSupportedMechanismTypes()
	{
		return mechanismTypes.iterator();
	}

	public void addDeserializer(Deserializer newDeserializer)
	{
		deserializers.addElement(newDeserializer);
		mechanismTypes.addElement(newDeserializer.getMechanismType());
	}
}
