/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;


import java.util.Vector;
import javax.xml.rpc.encoding.XMLType;
import javax.xml.namespace.QName;
import java.lang.Class;

public class Mapping {
  // JAVATypes2 for Java Array
  static Vector JAVATypes = new Vector(); static Vector JAVATypes2 = new Vector();
  static Vector XMLTypes  = new Vector();
  static Vector SOAPTypes = new Vector();
 
  public Mapping()
  {
   init();
  }
  
  public Class getType(QName xmlType)
  {
    if (XMLTypes.indexOf(xmlType) != -1 ) return (Class)JAVATypes.elementAt(XMLTypes.indexOf(xmlType));
    else if (SOAPTypes.indexOf(xmlType) != -1 ) return (Class)JAVATypes.elementAt(SOAPTypes.indexOf(xmlType));
    return null;
  }
  
  public QName getXMLType(Class javaType)
  {
    if (JAVATypes.indexOf(javaType) != -1 ) return (QName)XMLTypes.elementAt(JAVATypes.indexOf(javaType));
    else if (JAVATypes2.indexOf(javaType) != -1 ) return (QName)XMLTypes.elementAt(JAVATypes2.indexOf(javaType));
    return null;
  }
  
  public QName getSOAPType(Class javaType)
   {
     if (JAVATypes.indexOf(javaType) != -1 ) return (QName)SOAPTypes.elementAt(JAVATypes.indexOf(javaType));
     else if (JAVATypes2.indexOf(javaType) != -1 ) return (QName)SOAPTypes.elementAt(JAVATypes2.indexOf(javaType));
     return null;
   }
  
  public boolean isSimpleType(Class javaType)
  {
    if (JAVATypes.indexOf(javaType) != -1) return true;
    return false;
  }
  
  public boolean isArrayType(Class javaType)
  {
    if (JAVATypes2.indexOf(javaType) != -1) return true;
    return false;
  }
  
  public boolean isSimpleType(QName xmlType)
  {
    if (XMLTypes.indexOf(xmlType) > 1 || SOAPTypes.indexOf(xmlType) > 1 ) return true;
    return false;
  }
  
  public boolean isArrayType(QName xmlType)
  {
    if (SOAPTypes.indexOf(xmlType) == 1) return true;
    return false;
  }

  public Object getObject(String value, QName xmlType)
  {
      Object forReturn =null;
      int i = XMLTypes.indexOf(xmlType);
      if (i == -1) i = SOAPTypes.indexOf(xmlType);
      switch (i)
      {
        case 3:
          forReturn = new java.lang.Boolean(value);
          break;
        case 4:
          forReturn = new java.lang.Byte(value);
          break;
        case 14:
          forReturn = new java.lang.Short(value);
          break;
        case 10:
          forReturn = new java.lang.Integer(value);
          break;
        case 12:
          forReturn = new java.lang.Long(value);
          break;
        case 8:
          forReturn = new java.lang.Float(value);
          break;
        case 7:
          forReturn = new java.lang.Double(value);
          break;
        case 15:
          forReturn = new java.lang.String(value);
          break;
        case 11:
          forReturn = new java.math.BigInteger(value);
          break;
        case 6:
          forReturn = new java.math.BigDecimal(value);
          break;
          // probleme de calendar
        case 5:
          //forReturn = new java.util.Calendar();
          break;
        default:
          forReturn = new java.lang.String(value);
      }
     return forReturn;
  }
  private void init()
  {
    SOAPTypes.addElement(QName.valueOf("anytype")); XMLTypes.addElement(QName.valueOf("anytype")); JAVATypes.addElement(Object.class); JAVATypes2.addElement(Object[].class);
    SOAPTypes.add(XMLType.SOAP_ARRAY);              XMLTypes.addElement("null");                 JAVATypes.addElement(Object.class);JAVATypes2.addElement(Object[].class);
    SOAPTypes.add(XMLType.SOAP_BASE64);             XMLTypes.addElement(XMLType.XSD_BASE64);     JAVATypes.addElement(Object.class);JAVATypes2.addElement(Object[].class);
    SOAPTypes.add(XMLType.SOAP_BOOLEAN);            XMLTypes.addElement(XMLType.XSD_BOOLEAN);    JAVATypes.addElement(boolean.class);JAVATypes2.addElement(boolean[].class);
    SOAPTypes.add(XMLType.SOAP_BYTE);               XMLTypes.addElement(XMLType.XSD_BYTE);       JAVATypes.addElement(byte.class);JAVATypes2.addElement(byte[].class);
    SOAPTypes.add("null");                          XMLTypes.addElement(XMLType.XSD_DATETIME);   JAVATypes.addElement(java.util.Calendar.class);JAVATypes2.addElement(java.util.Calendar[].class);
    SOAPTypes.add("null");                          XMLTypes.addElement(XMLType.XSD_DECIMAL);    JAVATypes.addElement(java.math.BigDecimal.class);JAVATypes2.addElement(java.math.BigDecimal[].class);
    SOAPTypes.add(XMLType.SOAP_DOUBLE);             XMLTypes.addElement(XMLType.SOAP_DOUBLE);    JAVATypes.addElement(double.class);JAVATypes2.addElement(double[].class);
    SOAPTypes.add(XMLType.SOAP_FLOAT);              XMLTypes.addElement(XMLType.XSD_FLOAT);      JAVATypes.addElement(float.class);JAVATypes2.addElement(float[].class);
    SOAPTypes.add("null");                          XMLTypes.addElement(XMLType.XSD_HEXBINARY);  JAVATypes.addElement(Object.class);JAVATypes2.addElement(Object[].class);
    SOAPTypes.add(XMLType.SOAP_INT);                XMLTypes.addElement(XMLType.XSD_INT);        JAVATypes.addElement(int.class);JAVATypes2.addElement(int[].class);
    SOAPTypes.add("null");                          XMLTypes.addElement(XMLType.XSD_INTEGER);    JAVATypes.addElement(java.math.BigInteger.class);JAVATypes2.addElement(java.math.BigInteger[].class); 
    SOAPTypes.add("null");                          XMLTypes.addElement(QName.valueOf("http://www.w3.org/2001/XMLSchema}biginteger"));    JAVATypes.addElement(java.math.BigInteger.class);JAVATypes2.addElement(java.math.BigInteger[].class);
    SOAPTypes.add(XMLType.SOAP_LONG);               XMLTypes.addElement(XMLType.XSD_LONG);       JAVATypes.addElement(long.class);JAVATypes2.addElement(long[].class);
    SOAPTypes.add("null");                          XMLTypes.addElement(XMLType.XSD_QNAME);      JAVATypes.addElement(javax.xml.namespace.QName.class);JAVATypes2.addElement(javax.xml.namespace.QName[].class);
    SOAPTypes.add(XMLType.SOAP_SHORT);              XMLTypes.addElement(XMLType.XSD_SHORT);      JAVATypes.addElement(short.class);JAVATypes2.addElement(short[].class);
    SOAPTypes.add(XMLType.SOAP_STRING);             XMLTypes.addElement(XMLType.XSD_STRING);     JAVATypes.addElement(String.class);JAVATypes2.addElement(String[].class);
  }
}
