/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;

import csoap.xml.soap.*;
import javax.xml.namespace.QName;
import javax.xml.soap.Name;
import javax.xml.rpc.encoding.TypeMappingRegistry;

public class SerializerBase64 implements SerializerBase {
    
    String mechanismType="default";
    QName XMLType = javax.xml.rpc.encoding.XMLType.XSD_BASE64 ;
    Class JAVAType = byte[].class;
  
    public SerializerBase64(Class jAVAType,QName xMLType) 
    {
    	XMLType = xMLType;	
        JAVAType = jAVAType;
    }
    
    public String getMechanismType() 
    {
        return mechanismType;
    }
    
    public javax.xml.soap.SOAPElement serialize(Object obj, Name name, javax.xml.soap.SOAPElement SOAPParent, TypeMappingRegistry typeMappingRegistry)
    {
	
    	// CASTING OF JAX-RPC ON CSOAP CLASS IMPLEMENTATION
    	//	csoap.xml.rpc.encoding.TypeMappingRegistryImpl typeMappingRegistry2 = (csoap.xml.rpc.encoding.TypeMappingRegistryImpl)typeMappingRegistry;

    	csoap.xml.soap.SOAPElementImpl SOAPParent2 = (csoap.xml.soap.SOAPElementImpl)SOAPParent; 
	
    	SOAPElementImpl forReturn = new SOAPElementImpl((NameImpl)name);
    	String pre = null;
    	if (SOAPParent2 != null) pre =  SOAPParent2.getPrefixOf(XMLType.getNamespaceURI());
    	if (pre != null && !pre.equals(""))
	    {
    		forReturn.addAttribute(new NameImpl("type", "xsi"),pre + ":" + XMLType.getLocalPart()); 
	    }
    	else 
    	{ 
    		forReturn.addAttribute(new NameImpl("type", "xsi"), "nse:" + XMLType.getLocalPart());
    		forReturn.addNamespaceDeclaration("nse",XMLType.getNamespaceURI());
    	}
    	if (obj != null) forReturn.addTextNode(Base64.encode((byte[])obj));
    	else forReturn.addAttribute(new NameImpl("nil", "xsi"), "true");
    	return forReturn;
    }
    
    public void setMechanismType(String MechanismType)
    {
        mechanismType = MechanismType;
    }
}
