/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;

import javax.xml.rpc.encoding.*;
import java.util.Vector;
import java.util.Iterator;
import javax.xml.namespace.QName;

public class SerializerBase64Factory implements SerializerFactory
{
  Vector serializers = new Vector();
  Vector mechanismTypes = new Vector();

    public SerializerBase64Factory(Class JavaClass,  QName XmlType)
    {
    	this.addSerializer(new SerializerBase64(JavaClass, XmlType));
    }
    
    public SerializerBase64Factory()
    {
    	this.addSerializer(new SerializerBase64(byte[].class, javax.xml.rpc.encoding.XMLType.XSD_BASE64));
    }
    
    public Serializer getSerializerAs(String mechanismType)
    {
    	return (Serializer)serializers.elementAt(mechanismTypes.indexOf(mechanismType));
    }
    
    public Iterator getSupportedMechanismTypes()
    {
    	return mechanismTypes.iterator();
    }
    
    public void addSerializer(Serializer newSerializer)
    {
    	serializers.addElement(newSerializer);
    	mechanismTypes.addElement(newSerializer.getMechanismType());
    }
    
}
