/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;

import java.lang.reflect.*;
import java.lang.reflect.Field;
import csoap.xml.soap.*;
import javax.xml.namespace.QName;
import javax.xml.soap.Name;



public class SerializerComplexType implements SerializerBase
{
  String mechanismType ="default";
  QName XMLType;
  Class JAVAClass;
  
  public SerializerComplexType(Class JavaClass,  QName XmlType)
  {
       JAVAClass = JavaClass;
       XMLType = XmlType;
  }
  
  public String getMechanismType()
  {
	  return mechanismType;
  }
  
  public javax.xml.soap.SOAPElement serialize(Object obj, Name name, javax.xml.soap.SOAPElement SOAPParent, javax.xml.rpc.encoding.TypeMappingRegistry typeMappingRegistry)
  {
 
	  // CASTING OF JAX-RPC ON CSOAP CLASS IMPLEMENTATION
	  csoap.xml.soap.SOAPElementImpl SOAPParent2 = (csoap.xml.soap.SOAPElementImpl)SOAPParent; 

	  // CREATION OF SOAP ELEMENT
	  SOAPElementImpl forReturn = new SOAPElementImpl((NameImpl)name);
	  String pre = null;
	  if (SOAPParent2 != null) pre = SOAPParent2.getPrefixOf(XMLType.getNamespaceURI());
	  if (pre != null && !pre.equals(""))
      {
		  forReturn.addAttribute(new NameImpl("type", "xsi"),pre + ":" + XMLType.getLocalPart()); 
      }
	  else 
      { 
		  forReturn.addAttribute(new NameImpl("type", "xsi"), "nsc:" + XMLType.getLocalPart());
		  forReturn.addNamespaceDeclaration("nsc",XMLType.getNamespaceURI());
      }
	  
	  csoap.wsdl.TypeDesc typeDesc = null;
	  try
      {
		  Method getTypeDesc =  JAVAClass.getMethod("getTypeDesc", new Class[]{});
		  typeDesc = (csoap.wsdl.TypeDesc)getTypeDesc.invoke(obj,new Object[]{});
      }
	  catch(Exception ex)
      {
          ex.printStackTrace();
          System.out.println("This Class is not generated by CSoap generator");
      }
  
	  if (obj != null)
      {
		  // CREATION OF SOAP ELEMENT CHILD FOR ALL ATTRIBUTES
		  try
	      {
			  Field Attributes[] = JAVAClass.getFields();
		  		for (int i = 0; i < Attributes.length; i++)
		  		{
		  			Field attribute = Attributes[i];
		  			Object value = attribute.get(obj);
		  			String nameAtt = attribute.getName();
		  			Class typeAtt = attribute.getType();
		  			csoap.wsdl. ElementDesc elementDesc = typeDesc.getFieldE(nameAtt);
		  			QName XMLTypeAtt = elementDesc.getXmlType();
		  			// FIND PREFIX FOR XMLTYPEATTRIBUTE
		  			pre = forReturn.getPrefixOf(XMLTypeAtt.getNamespaceURI());
		  			if ((pre == null || pre.equals("")) && SOAPParent2 != null) pre = SOAPParent2.getPrefixOf(XMLTypeAtt.getNamespaceURI());
		  			if (pre == null || pre.equals(""))
		  				forReturn.addNamespaceDeclaration("nse"+(i+1),XMLTypeAtt.getNamespaceURI());
			  
		  			// FIND SERIALISER FOR THIS ATTRIBUT
		  			javax.xml.rpc.encoding.TypeMapping typeMapping = typeMappingRegistry.getTypeMapping(XMLTypeAtt.getNamespaceURI());
		  			javax.xml.rpc.encoding.SerializerFactory serializerFactory = typeMapping.getSerializer(typeAtt, XMLTypeAtt);
		  			SerializerBase serializer = (SerializerBase) serializerFactory.getSerializerAs("default");    
		  			forReturn.addChildElement((SOAPElementImpl)serializer.serialize(value,new NameImpl(nameAtt),forReturn, typeMappingRegistry));
		  		}
	      }
		  catch (Exception ex)
	      {
			  System.out.println("ERROR IN serialise Class  : "+JAVAClass.getName());
	      }
      }
	  else //OBJ IS NULL
		  forReturn.addAttribute(new NameImpl("nil", "xsi"),"true"); 
	
	  return forReturn;
  	}
    
}
