/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;

import javax.xml.rpc.encoding.*;
import java.util.Vector;
import java.util.Iterator;
import javax.xml.namespace.QName;

public class SerializerComplexTypeFactory implements SerializerFactory
{
  Vector serializers = new Vector();
  Vector mechanismTypes = new Vector();

  public SerializerComplexTypeFactory(Class JavaClass,  QName XmlType)
  {
	  this.addSerializer(new SerializerComplexType(JavaClass,XmlType));
  }

  public Serializer getSerializerAs(String mechanismType)
  {
	  return (Serializer)serializers.elementAt(mechanismTypes.indexOf(mechanismType));
  }

  public Iterator getSupportedMechanismTypes()
  {
	  return mechanismTypes.iterator();
  }

  public void addSerializer(Serializer newSerializer)
  {
	  serializers.addElement(newSerializer);
	  mechanismTypes.addElement(newSerializer.getMechanismType());
  }

}




