/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.encoding;

import javax.xml.rpc.encoding.*;
import java.util.Vector;
import java.util.Iterator;

public class SerializerFactoryImpl implements SerializerFactory 
{
    Vector serializers = new Vector();
    Vector mechanismTypes = new Vector();

    public SerializerFactoryImpl() {}

    public Serializer getSerializerAs(String mechanismType) {
        return (Serializer)serializers.elementAt(mechanismTypes.indexOf(mechanismType));
    }

    public Iterator getSupportedMechanismTypes() {
        return mechanismTypes.iterator();
    }

    public void addSerializer(SerializerBase newSerializer) {
        serializers.addElement(newSerializer);
        mechanismTypes.addElement(newSerializer.getMechanismType());
    }

}