/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.rpc.handler;

import java.util.Map;
import java.util.*;
import javax.xml.rpc.handler.Handler;
import csoap.deployment.handlerFlow;


public class HandlerChainImpl extends Vector implements javax.xml.rpc.handler.HandlerChain {

  String[] roles;
  Vector handlersNames = new Vector();
  handlerFlow flow;


  public void destroy()
  {
    ///kill handler
    for (int i=0;i<super.size();i++)
      ((Handler)super.get(i)).destroy();
    super.removeAllElements();

  }

  public String[] getRoles()
  {
    return roles;
  }
  
  public boolean handleFault(javax.xml.rpc.handler.MessageContext context)
  {
    return true;
  }
  
  public boolean handleRequest(javax.xml.rpc.handler.MessageContext context)
  {
    Iterator ite;
    try
    {
      if (super.isEmpty()) {
        ite = flow.getHandlers();
        while (ite.hasNext()) {
          HandlerInfo2 handlerInfo = (HandlerInfo2) ite.next();
          Class classHandler  = handlerInfo.getHandlerClass();
          Handler instanceHandler = (Handler)classHandler.newInstance();
          instanceHandler.init(handlerInfo);
          super.addElement(instanceHandler);
          handlersNames.addElement((String)handlerInfo.getHandlerName());
        }

      }
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }

    ite = flow.getRequestFlow();

    while ( ite.hasNext() )
    {
      String requestHandler = (String) ite.next();
      ((Handler)super.elementAt(handlersNames.indexOf(requestHandler))).handleRequest(context);
    }
    return true;
  }

  public boolean handleResponse(javax.xml.rpc.handler.MessageContext context)
  {
    Iterator ite;
     try
     {
       if (super.isEmpty()) {
         ite = flow.getHandlers();
         while (ite.hasNext()) {
           HandlerInfo2 handlerInfo = (HandlerInfo2)ite.next();
           Class classHandler = handlerInfo.getHandlerClass();
           Handler instanceHandler = (Handler)classHandler.newInstance();
           instanceHandler.init(handlerInfo);
           super.addElement(instanceHandler);
           handlersNames.addElement((String)handlerInfo.getHandlerName());
         }

       }
     }
     catch (Exception ex)
     {
       ex.printStackTrace();
     }


     ite = flow.getResponseFlow();
     while ( ite.hasNext() )
     {
    	 String responseHandler = (String) ite.next();
    	 ((Handler)super.elementAt(handlersNames.indexOf(responseHandler))).handleResponse(context);
     }
     return true;
  }


  public void init(Map config)
  {
    flow = (handlerFlow)config.get("handlerFlow");
  }
  
  public void setRoles(String[] soapActorNames)
  {
	roles = soapActorNames;
  }
}