/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.soap;

import java.io.*;
import org.xml.sax.InputSource;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.XMLReader;


public class MessageFactoryImpl extends javax.xml.soap.MessageFactory
{
   
    XMLReader xr ;
    SAXHandler sh;
  
    public MessageFactoryImpl()
    {
        xr = new SAXParser();
        sh = new SAXHandler();
        xr.setContentHandler(sh);
        xr.setErrorHandler(sh);
    }

  
    public javax.xml.soap.SOAPMessage createMessage()
    {
        return new SOAPMessageImpl();
    }
    
    public javax.xml.soap.SOAPMessage createMessage(javax.xml.soap.MimeHeaders mimeHeaders, InputStream inputStream) 
    {
    	try
    	{
            xr.parse(new InputSource(inputStream));
            SOAPMessageImpl  message = sh.getSOAPMessage();
            return message;
        } 
    	catch (Exception ex) 
    	{
            ex.printStackTrace();
            return null;
        }
    }

 }
