/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.soap;

import java.util.Iterator;
import java.util.Vector;

public class MimeHeadersImpl extends javax.xml.soap.MimeHeaders {

  // Champs
  private Vector headers;
  private MimeHeaderImpl mimeHeader;

  // Constructeurs
  public MimeHeadersImpl() { }

  // Mthodes
  public String[] getHeader(String name)
  {
    String forReturn[] = new String[headers.size()];
    int j=0;
    for (int i=0; i<headers.size();i++)
    {
      mimeHeader = (MimeHeaderImpl)headers.elementAt(i);
      if (mimeHeader.getName().equals(name))
        {
          forReturn[j] = mimeHeader.getValue();
          j++;
        }
    }

    return forReturn;
  }

  public void setHeader(String name, String value)
  {
    int i =0;
    boolean found= false;
    while (i<headers.size() &&  !found)
     {
       mimeHeader = (MimeHeaderImpl)headers.elementAt(i);
       if (mimeHeader.getName().equals(name)) found = true;
       else i++;
     }
     if (i<headers.size())
     {
       headers.removeElementAt(i);
       headers.insertElementAt(new MimeHeaderImpl(name, value),i);
     }
  }

  public void addHeader(String name, String value)
  {
    headers.addElement(new MimeHeaderImpl(name, value));
  }
  
  public void removeHeader(String name)
  {
    int i =0;
    while (i<headers.size())
    {
      mimeHeader = (MimeHeaderImpl)headers.elementAt(i);
      if (mimeHeader.getName().equals(name)) headers.removeElementAt(i);
      else i++;
    }
  }
  
  public void removeAllHeaders()
  {
    headers.removeAllElements();
  }
  
  public Iterator getAllHeaders()
  {
    return headers.iterator();
  }
  
  
  public Iterator getMatchingHeaders(String[] names)
  {
	// Not implemented
    return null;
  }
  
  public Iterator getNonMatchingHeaders(String[] names)
  {
	// Not implemented  
    return null;
  }

}
