/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.soap;

import javax.xml.soap.*;
import javax.xml.namespace.QName;

public class NameImpl implements Name
{
  String localName="", prefix="", uri="", qualifiedName="";

  public NameImpl(QName QualifiedName)
  {
    this.qualifiedName = QualifiedName.toString();
    if (this.qualifiedName.indexOf(":") !=-1)
    {
      prefix = this.qualifiedName.substring(0,this.qualifiedName.indexOf(":"));
      localName = this.qualifiedName.substring(this.qualifiedName.indexOf(":")+1);
    }
    else localName = this.qualifiedName;
  }
  
  public NameImpl(String LocalName) 
  {
    localName = LocalName;
  }
  
  public NameImpl(String LocalName, String Prefix)
  {
    localName = LocalName;
    prefix = Prefix;
  }
  
  public NameImpl(String LocalName, String Prefix, String Uri)
  {
    localName = LocalName;
    prefix = Prefix;
    uri = Uri;
  }


  public String getLocalName()
  {
    return localName;
  }
  
  public String getPrefix()
  {
    return prefix;
  }
  
  public String getQualifiedName()
  {
    if (prefix != null && !prefix.equals("")) return prefix+":"+localName;
    else return localName;
  }
  
  public String getURI()
  {
    return uri;
  }

  public boolean equals2(Name name)
  {
    if ((localName.equals(name.getLocalName())) && ( prefix.equals(name.getPrefix()) || name.getPrefix()=="" ) && (uri.equals(name.getURI()) || name.getURI()==""))
    return true;
    else return false;
  }
  
}
