/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.soap;

import java.net.*;
import javax.xml.soap.*;

public class SOAPConnectionImpl extends SOAPConnection
{
    java.net.HttpURLConnection urlConn;
    java.net.URL url;
    String id="";
    boolean connect = false;

  MessageFactoryImpl factory = new MessageFactoryImpl();
  
  public SOAPConnectionImpl() {}

  public SOAPMessage call(SOAPMessage sOAPMessage, Object endPoint) {
   try {

	       url = new java.net.URL(endPoint.toString());
	       urlConn = (java.net.HttpURLConnection)url.openConnection();
	       connect = true;
	       urlConn.setDoInput (true);
	       urlConn.setDoOutput (true);
	       urlConn.setUseCaches (false);
	       urlConn.setRequestProperty("User-Agent", "Profile/MIDP-1.0 Configuration/CLDC-1.0");
	       urlConn.setRequestProperty("Content-Language", "en-US");
	       urlConn.setRequestProperty("content-Type", "application/x-www-form-urlencoded");
	       
	       // required for Axis compatibility
	       String action = url.getPath();
	                 
	       urlConn.setRequestProperty("SOAPAction",action);
	       urlConn.setRequestProperty("Cookie","id="+id);
	       
	       java.io.OutputStream os = urlConn.getOutputStream();
	       sOAPMessage.writeTo(os);
	       os.close();
	       while (urlConn.getResponseCode() != HttpURLConnection.HTTP_OK){}   
	       java.io.InputStream is = urlConn.getInputStream();
	       String cookies = urlConn.getHeaderField("Set-Cookie");
       
	       SOAPMessage sOAPResponse = factory.createMessage(null, is);
	       is.close();
	       if (cookies != null && cookies.indexOf("id")!=-1) 
	       {
	    	   cookies = cookies.substring(cookies.indexOf("id=")+3); 
	    	   if (cookies.indexOf(";")!=-1) id = cookies.substring(0,cookies.indexOf(";"));
	    	   else id = cookies;
	    	   id = id.trim(); 
	       }	
       return sOAPResponse;
   }
   catch (Exception ex) {
       ex.printStackTrace();
   }
   return null;
  }
    
  public void close()
  {
	  connect = false;
	  urlConn.disconnect();
  }
    
  public void callOneWay(SOAPMessage sOAPMessage, Object endPoint)
  {
	  try
	  {
		  url = new java.net.URL(endPoint.toString());
		  urlConn = (java.net.HttpURLConnection)url.openConnection();
		  connect = true;
		  urlConn.setDoInput (true);
		  urlConn.setDoOutput (true);
		  urlConn.setUseCaches (false);
		  urlConn.setRequestProperty("User-Agent", "Profile/MIDP-1.0 Configuration/CLDC-1.0");
		  urlConn.setRequestProperty("Content-Language", "en-US");
		  urlConn.setRequestProperty("content-Type", "application/x-www-form-urlencoded");
	  
	       // required for Axis compatibility
		  String action = url.getPath();
		  
		  urlConn.setRequestProperty("SOAPAction",action);
		  urlConn.setRequestProperty("Cookie","id="+id);
		  java.io.OutputStream os = urlConn.getOutputStream();
		  sOAPMessage.writeTo(os);
		  os.close();
		  while (urlConn.getResponseCode() != HttpURLConnection.HTTP_OK){}   
           
		  String cookies = urlConn.getHeaderField("Set-Cookie");
		  if (cookies != null && cookies.indexOf("id")!=-1) 
		  {
			  cookies = cookies.substring(cookies.indexOf("id=")+3); 
			  if (cookies.indexOf(";")!=-1) id = cookies.substring(0,cookies.indexOf(";"));
			  else id = cookies;
			  id = id.trim(); 
		  }
	  }
	  catch (Exception ex) 
	  {
       ex.printStackTrace();
	  }
  }

}
