/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.soap;

import javax.xml.namespace.QName;
import javax.xml.soap.*;

public class SOAPHeaderElementImpl extends SOAPElementImpl implements SOAPHeaderElement
{
  
	String actor;
  boolean mustUnderstand;
  
  public SOAPHeaderElementImpl(NameImpl name)
  {
    super(name);
  }

  public SOAPHeaderElementImpl(QName qualifiedName)
  {
     super(qualifiedName);
  }
  
  public SOAPHeaderElementImpl(String localName, String prefix)
  {
    super(localName,prefix);
  }
  
  public SOAPHeaderElementImpl(String localName)
  {
    super(localName);
  }
  
  public SOAPHeaderElementImpl(String localName, String prefix, String uri)
  {
    super(localName, prefix, uri);
  }
  
  public String getActor()
  {
    return getAttributeValue(new NameImpl("actor"));
  }
  
  public boolean getMustUnderstand()
  {
    if (((String)getAttributeValue(new NameImpl("mustUnderstand"))).equals("true")) return true ;
    else return false;
  }
  
  public void setActor(String actorURI)
  {
    addAttribute(new NameImpl("actor"),actorURI);
  }
  
  public void setMustUnderstand(boolean MustUnderstand)
  {
    if (MustUnderstand) addAttribute(new NameImpl("mustUnderstand"), "true");
    else addAttribute(new NameImpl("mustUnderstand"), "false");
  }

}
