/**
*
* CSoap Implementation, INRIA-Rocquencourt, ARLES Project
* 
* @author Rafik CHIBOUT 
* @version 1.0
*  
*/

package csoap.xml.soap;

// Imports
import java.util.Iterator;
import javax.xml.transform.Source;


public class SOAPPartImpl extends javax.xml.soap.SOAPPart {
  private SOAPEnvelopeImpl sOAPEnvelope = new SOAPEnvelopeImpl();
  private MimeHeadersImpl mimeHeaders;
  private String contentId, contentLocation;
  private Source content;

  // Constructeurs
  public SOAPPartImpl() { }

  // Mthodes
  public javax.xml.soap.SOAPEnvelope getEnvelope()
  {
    return sOAPEnvelope;
  }
  
  public String getContentId()
  {
    return contentId;
  }
  
  public String getContentLocation()
  {
    return contentLocation;
  }
  
  public void setContentId(String ContentId)
  {
    contentId= ContentId;
  }
  
  public void setContentLocation(String ContentLocation)
  {
    contentLocation = ContentLocation;
  }
  
  public void removeMimeHeader(String name)
  {
    mimeHeaders.removeHeader(name);
  }
  
  public void removeAllMimeHeaders()
  {
    mimeHeaders.removeAllHeaders();
  }
  
  public String[] getMimeHeader(String name)
  {
    return mimeHeaders.getHeader(name);
  }
  
  public void setMimeHeader(String name, String value)
  {
    mimeHeaders.setHeader(name,value);
  }
  
  public void addMimeHeader(String name, String value)
  {
    mimeHeaders.addHeader(name, value);
  }
  
  public Iterator getAllMimeHeaders()
  {
    return mimeHeaders.getAllHeaders();
  }
  
  public Iterator getMatchingMimeHeaders(String[] names)
  {
    return mimeHeaders.getMatchingHeaders(names);
  }
  
  public Iterator getNonMatchingMimeHeaders(String[] names)
  {
    return mimeHeaders.getNonMatchingHeaders(names);
  }
  
  public void setContent(Source source)
  {
    content = source;
  }
  
  public Source getContent()
  {
    return content;
  }
}

