/*
*
* Generator.java
*
* @author Mirco Musolesi
* @author Rafik CHIBOUT
* @version 0.1 July 2003
*
*  
*/


package csoap.wsdl;

import javax.wsdl.*;
import javax.wsdl.factory.*;
import javax.wsdl.xml.*;
import javax.xml.namespace.*;
import javax.wsdl.extensions.*;
import javax.wsdl.extensions.soap.*;

//WSIF
import org.apache.wsif.schema.*;
import org.apache.wsif.wsdl.*;
 
import java.io.*;
import java.net.URL;
import java.net.MalformedURLException;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;


public class DeploymentGenerator {


    // boolean BigDecimalSupported = false;


    //**************************************************
    // ADD FOR EXTENDS CORRECTLY THIS CLASS BY GENERATOR
    //**************************************************

    //Constants
	//prefix constant definition
	String prefixOperationQName="operNS";
        String prefixReturnTypeNamespace="rtNS";
	//encodingStyle constant definition
	String encodingStyle="http://schemas.xmlsoap.org/soap/encoding/";
	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String serializerClassName="csoap.xml.rpc.encoding.SerializerComplexTypeFactory";
	String deserializerClassName="csoap.xml.rpc.encoding.DeserializerComplexTypeFactory";
       	String arraySerializerClassName="csoap.xml.rpc.encoding.SerializerArrayFactory";
	String arrayDeserializerClassName="csoap.xml.rpc.encoding.DeserializerArrayFactory";
	
	//input parameters
	boolean debug=false;
	boolean restrDebug=false;
	boolean clientSide=false; //indicates the way of retrieving data -->it exploits the interface wsdl file only
	boolean serverSide=false; //indicates the way of retrieving data -->it exploits the interface and concrete files 
	//PLEASE NOTE: these boolean values are not referred to the files that will be generated, but only to the way
	//of retrieving information
	
	boolean generateClientFilesOnly=false; //indicates which files are to be generated
					       // true-->client-side  false-->server-side
	
	//Class variables
	Definition def=null;
	String serviceName=new String();
	String defName=new String();
	Port port=null;
	Binding serviceBinding=null;
	String portTypeName=new String();
	Vector bindingOperationsVector=new Vector();
	Vector operationsVector=new Vector(); //contains operations data only
	Vector holderDataVector=new Vector(); //contains information about holders that have to be generated
	OperationData[] opData=null; //contains operations and param data
	SchemaType[] typesData=null; //contains types section data
	int bindingOperationsNum=0;
	int operationsNum=0;
	
	//System properties
	String fileSeparator=System.getProperty("file.separator");
    

    // ANOTHER VARIABLES
    PortType portType=null;
    Binding bin=null;
    int requestMessagePartsNum;
    ParData[] requestMessageParDataArray;
    Part part;
    ParData parData;
    QName typeQName;
    String typeQNameLocalPart;
    String typeQNameNameSpaceURI;
    Message messageResponse;
    List parameterOrderingList;
    List responseMessageParts;
    Iterator responseMessagePartsIterator;
    int responseMessagePartsNum;
    ParData[] responseMessageParDataArray;
    Map faultMap;
    Collection faultValues;
    Iterator faultValuesIterator;
    int FaultNumber;
    ExceptionData[] excArr;
    int faultCounter;
    Fault faultItem;
    Message relatedMessage;				
    String exceptionName;
    List parList;
    List relatedMessagePartsList;
    Iterator relatedMessagePartsIterator;
    int partNum;
    ExceptionParData[] excParArr;
    int partCounter;
    Part relatedMessagePartItem;
    String relatedMessagePartName;
    String relatedMessagePartType_LocalPart;
    String relatedMessagePartType_Namespace;	
    ExceptionParData exceptionParDataItem;
    ExceptionData excData;
    org.apache.wsif.schema.Parser schemaParser;
    List schemaTypes;
    Definition def1;
    ClassLoader cl;
    WSIFWSDLLocatorImpl locWSIF;		
    WSDLLocator loc=(WSDLLocator)locWSIF;
    List schemaTypesList;
    Iterator schemaTypesIterator;
    int s;
    Operation operationElement;
    ParData[] parRequest;
    ParData[] parResponse;
    String javaTypeDef;
    String packageName;
    String interfaceDirName;
    File dir;
    FileWriter fw;
    String initialLetterString;
    String lowerCaseInitialLetterString;
    String subString;
    String lowerCaseOperationName;
    String parPrefix;
    WSDLFactory factory;
    WSDLReader reader;
    Map serv;
    Collection serVal;
    Map services;
    QName serviceQName;
    Collection valuesServices;
    Iterator valuesServicesIterator;
    Service service;
    Map ports;
    Collection valuesPorts;
    Iterator valuesPortsIterator;
    List bindingOperations;
    Iterator bindingOperationsIterator;
    BindingOperation bindOp;
    Map portTypes=null;
    Map bindings=null;
    Collection portTypesValues;
    Iterator portTypesValuesIterator;
    Collection bindingsValues;
    Iterator bindingsValuesIterator;
    List operations;
    Iterator operationsIterator;
    Operation op;
    String opName;
    Operation opEl;
    BindingOperation bindOperation;
    BindingInput bindInput;
    List extList;
    Iterator extListIterator;
    ExtensibilityElement extElement;
    SOAPBody soapExtElement;
    Input inp;
    Output out;
    Message messageRequest;
    List requestMessageParts;
    Iterator requestMessagePartsIterator;
    ExceptionData[] exceptions;
    ExceptionParData[] exceptionParam;
    String faultClassJavaType;
    String javaType;
    QName arrayTypeQName;
    String javaArrayTypeTemp;
    String javaArrayType;
    
    //************************

    // END OF SHARED VARIABLES
    //************************
/*
* Constructor
*/
    public DeploymentGenerator(){}



/**
* Gets the correct prefix given a namespace. If the namespace is unknown, it returns null
* @param nameSpace a namespace
* @return the prefix if the mapping is known, null otherwise.
*/
protected String getPrefix(String nameSpace) {


        String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String result=null;
	if (nameSpace.equals(schemaNameSpace1999))
		result="xsd";
        else if (nameSpace.equals(schemaNameSpace2000))
		result="xsd";
        else if (nameSpace.equals(schemaNameSpace2001))
		result="xsd";
	return result;
}




/**
* Gets the package given the whole type name.
* Example getPackageName(java.lang.String) is java.lang
* @param str string to be processed
* @return the package name
*/
protected String getPackageName (String str) {
 	int index=str.lastIndexOf(".");
 	String substring=str.substring(0,index);
 	return substring;
}




/**
* Gets the Java type that maps the given XML type. QName class represents the value of 
* a qualified name as specified in XML Schema Part2: Datatypes specification. 
* @param qname a qname type representing the given XML type to be converted
* @return the java type if the mapping is known or the suitable user-defined Java type
*/
protected String getJavaType (QName qname) {
	String localPart=qname.getLocalPart();
	String namespace=qname.getNamespaceURI();
	return getJavaType(localPart,namespace);
}




/**
* Gets the Java type that maps the given XML data type 
* @param XMLDataType a XML data type
* @param namespace its namespace
* @return the Java type if the mapping is known or the suitable user-defined Java type 
*/
protected String getJavaType (String XMLDataType, String namespace) {
		
	String ret=null;
	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String soapNameSpace="http://schemas.xmlsoap.org/soap/encoding/";
	String wsdlNameSpace="http://schemas.xmlsoap.org/wsdl/";
	//case XML Schema type)
	if ((namespace.equals(schemaNameSpace1999))||
	    (namespace.equals(schemaNameSpace2000))||
	    (namespace.equals(schemaNameSpace2001))) {
		if (XMLDataType.equals("string")) ret="java.lang.String";
		else if (XMLDataType.equals("integer")) ret="java.math.BigInteger"; 
		else if (XMLDataType.equals("int")) ret="int";
		else if (XMLDataType.equals("long")) ret="long";
		else if (XMLDataType.equals("short")) ret="short";
		else if (XMLDataType.equals("decimal")) ret="java.math.BigDecimal";
		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		/*
		  else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret="java.math.BigDecimal";
		  else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret="java.lang.Double";
		 */		
		else if (XMLDataType.equals("float")) ret="float";
		else if (XMLDataType.equals("double")) ret="double";
		else if (XMLDataType.equals("boolean")) ret="boolean";
		else if (XMLDataType.equals("byte")) ret="byte";
		else if (XMLDataType.equals("QName")) ret="java.xml.rpc.namespace.QName";
		else if (XMLDataType.equals("dateTime")) ret="java.util.Calendar";
		else if (XMLDataType.equals("base64Binary")) ret="byte[]";
		else if (XMLDataType.equals("hexBinary")) ret="byte[]";
	}
	else if (namespace.equals(soapNameSpace)) {
		if (XMLDataType.equals("string")) ret="java.lang.String";
		else if (XMLDataType.equals("boolean")) ret="java.lang.Boolean";
		else if (XMLDataType.equals("float")) ret="java.lang.Float";
		else if (XMLDataType.equals("double")) ret="java.lang.Double";
		else if (XMLDataType.equals("decimal")) ret="java.math.BigDecimal";

		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		/*	else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret="java.math.BigDecimal";
		else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret="java.lang.Double";
		*/
		else if (XMLDataType.equals("int")) ret="java.lang.Integer";
		else if (XMLDataType.equals("short")) ret="java.lang.Short";
		else if (XMLDataType.equals("byte")) ret="java.lang.Byte";
		else if (XMLDataType.equals("base64")) ret="Byte[]";
	}

	
	else if (namespace.substring(0,4).equals("urn:")) {
		//case URN-type namespace
		String namePackage=resolveNamespaceURN(namespace);	
		String upperCaseXMLDataType=firstLetterToUpperCase(XMLDataType);
		ret=namePackage+"."+upperCaseXMLDataType;
	} else	{	
		//everithing else (URL style namespace)
		String namePackage=resolveNamespaceURL(namespace);
		String upperCaseXMLDataType=firstLetterToUpperCase(XMLDataType);
		ret=namePackage+upperCaseXMLDataType;
	}

    	//System.out.println("XMLDataType="+XMLDataType+"  namespace="+namespace+"   javaType="+ret);
	
	return ret;

}

	

/**
* Resolves URN-type namespaces, trasforming them into package names according the specification
*	
* @param nsURN a URN-type namespace
* @return the package name according the specification
*/

protected String resolveNamespaceURN (String nsURN) {
	
	
	// PLEASE NOTE: Current limitations
	// The current implementation is able to manage a namespace with the following form:
	// 
	// NSS=TOK1["."TOK1]*
	// TOK1=AlphaChar[AlphaNumChar]*
	//
	//
	String ret=new String("");
	String localPartNameSpace=null;
	String initialPartNameSpace=nsURN.substring(0,4);
	localPartNameSpace=nsURN.substring(4);
	
	//changing ":" with "."
	
	StringTokenizer strTok=new StringTokenizer(localPartNameSpace,".");
	int numTokens=strTok.countTokens();
	String[] fragments=new String[numTokens];
	StringBuffer strBuf=new StringBuffer();
	int k=0;
	while (strTok.hasMoreTokens()) {
		fragments[k]=strTok.nextToken();
		k++;
	}
	for (int p=numTokens-1;p>-1;p--) {
		//case of a fragment (a token) beginning with a digit
		if (startWithADigit(fragments[p]))
			fragments[p]=addAnUnderscoreBefore(fragments[p]);
			
		strBuf.append(fragments[p]);
		if (p!=0)
			strBuf.append(".");
	}
	
	
	ret=strBuf.toString(); //temporary
	
	
	return ret;
	
	
}// end resolveNameSpaceURN




/**
* Resolves URL-type namespaces, trasforming them into package names according the specification
* @param nsURI a URL-type namespace
* @return the package name according the specification
* 
*/
protected String resolveNamespaceURL (String nsURI) {
 
	String ret=new String("");
	
	try {
		//creating URL...
		URL url=new URL(nsURI);
		
		//processing the so-called host part...
		String hostPart=url.getHost();
		//System.out.println("hostPart: "+hostPart);
		StringTokenizer strTok=new StringTokenizer(hostPart,".");
		int numTokens=strTok.countTokens();
		//System.out.println("The number of tokens is "+numTokens);
		String[] fragments=new String[numTokens];
		StringBuffer strBuf=new StringBuffer();
		int k=0;
		while (strTok.hasMoreTokens()) {
			fragments[k]=strTok.nextToken();
			k++;
		}
		for (int p=numTokens-1;p>-1;p--) {
			//System.out.println("p value is "+p+" when token is "+fragments[p]);
			strBuf.append(fragments[p]);
			if (p!=0)
				strBuf.append(".");	
		}
		
		//processing the so-called path part
		String pathPart=url.getPath();
		StringTokenizer strTok2=new StringTokenizer(pathPart,"/");
		int numTokens2=strTok2.countTokens();
		String[] fragments2=new String[numTokens2];
		StringBuffer strBuf2=new StringBuffer();
		k=0;
		while (strTok2.hasMoreTokens()) {
			String rawFragment=strTok2.nextToken();
			
			//Now we have to replace the character '.' with '_'
			StringTokenizer strTok3=new StringTokenizer(rawFragment,".");
			int numTokens3=strTok3.countTokens();
			String[] fragments3=new String[numTokens3];
			StringBuffer strBuf3=new StringBuffer();
		 	int r=0;
		 	while (strTok3.hasMoreTokens()) {
		 		fragments3[r]=strTok3.nextToken();
		 		r++;
			}
			for (int p=0;p<numTokens3;p++) {
				strBuf3.append(fragments3[p]);
				if (p<numTokens3-1)
					strBuf3.append("_");
			}
			fragments2[k]=strBuf3.toString();
			k++;
		}
		for (int p=0;p<numTokens2;p++) {
			strBuf2.append(fragments2[p]);
			if (p<numTokens2-1)
				strBuf2.append(".");
		}
						
			
		ret=strBuf.toString()+"."+strBuf2.toString();	
	}
	catch (MalformedURLException e) {
			System.err.println ("Error: invalid namespace definition.");
			e.printStackTrace();
	}
	
	
	//String nsURI.indexOf(":"); 
	//StringTokenizer strTok=new StringTokenizer(
	return ret;

}//end private String resolveNamespaceURL (String nsURI)




/**
* Converts the first letter of the given string to upper case
* @param str a string
* @return the given string with the first letter converted to upper case
*/
protected String firstLetterToUpperCase(String str) {
	String initialLetterString=str.substring(0,1);
	String upperCaseInitialLetterString=initialLetterString.toUpperCase();
	String subString=str.substring(1);
	String retString=upperCaseInitialLetterString+subString;
	return retString;
}




/**
* Converts the first letter of the given string to lower case
* @param str a string
* @return the given string with the first letter converted to lower case
*/
protected String firstLetterToLowerCase(String str) {
	String initialLetterString=str.substring(0,1);
	String lowerCaseInitialLetterString=initialLetterString.toLowerCase();
	String subString=str.substring(1);
	String retString=lowerCaseInitialLetterString+subString;
	return retString;
}




/**
* Add an underscore before the given string. This method is mainly used in the case of
* string that begin with numbers.
* @param str a string that is composed by an initial underscore character, followed by the given string
*/
protected String addAnUnderscoreBefore(String str) {
	String underscore="_";
	String ret=new String(underscore+str);
	return ret;
}




/**
* Returns true if the first character is a number, false otherwise.
* @param str a string
* @return true if the first character is a number, false otherwise
*/
protected boolean startWithADigit(String str) {
	boolean isADigit=false;
	char first=str.charAt(0);
	//System.out.println("The string is "+str);
	//System.out.println("First char is "+first);
	if (Character.isDigit(first)) {
		isADigit=true;
		//System.out.println(str+" starts with a digit");
	}
	return isADigit;
}



/**
* Generates files for deployng webservices applications.
* The following files are generated:
*
1) a WSDD deploy file
*
* @param fileName the WSDL file
* @param side indicates if the generation is for client or served side only. "c" stands for CLIENT, while "s" stands for server.
* @param dirName the directory for generated files
* @param verbose if true, debugging information are displayed
* @param implClass parameter implClass
* @return true if the generation is successful, false otherwise
*/
public boolean generateWSDD(String fileName, String side, boolean verbose,String dirName,String implClass, String scope) {
	
    /*
      //Constants
      //prefix constant definition
      String prefixOperationQName="operNS";
      String prefixReturnTypeNamespace="rtNS";
      //encodingStyle constant definition
      String encodingStyle="http://schemas.xmlsoap.org/soap/encoding/";
      String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
      String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
      String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
      String serializerClassName="csoap.xml.rpc.encoding.SerializerComplexTypeFactory";
      String deserializerClassName="csoap.xml.rpc.encoding.DeserializerComplexTypeFactory";
      String arraySerializerClassName="csoap.xml.rpc.encoding.SerializerArrayFactory";
      String arrayDeserializerClassName="csoap.xml.rpc.encoding.DeserializerArrayFactory";
      
      //input parameters
      boolean debug=false;
      boolean restrDebug=false;
      boolean clientSide=false; //indicates the way of retrieving data -->it exploits the interface wsdl file only
      boolean serverSide=false; //indicates the way of retrieving data -->it exploits the interface and concrete files 
      //PLEASE NOTE: these boolean values are not referred to the files that will be generated, but only to the way
      //of retrieving information
      
      boolean generateClientFilesOnly=false; //indicates which files are to be generated
      // true-->client-side  false-->server-side
	
      //Class variables
      Definition def=null;
      String serviceName=new String();
      String defName=new String();
      Port port=null;
      Binding serviceBinding=null;
      String portTypeName=new String();
      Vector bindingOperationsVector=new Vector();
      Vector operationsVector=new Vector(); //contains operations data only
      Vector holderDataVector=new Vector(); //contains information about holders that have to be generated
      OperationData[] opData=null; //contains operations and param data
      SchemaType[] typesData=null; //contains types section data
      int bindingOperationsNum=0;
      int operationsNum=0;
	
      //System properties
      String fileSeparator=System.getProperty("file.separator");
    */
	
    //****************************
    //Zero phase - generator setup
    //****************************
	
	//processing client/server side parameter
	if (side.equals("c"))
		clientSide=true;
	if (side.equals("s"))
		serverSide=true;
		
	if (side.equals("c"))
		generateClientFilesOnly=true;	
		
	//processing verbose parameter
	if (verbose) 
		debug=true;
	
		
	//Generator processing parameter values debugging
	if (debug) {
	    //System.out.println("Generator processing parameter values");
	    //System.out.println("debug="+debug);
	    //System.out.println("restrDebug="+restrDebug);
	    //System.out.println("clientSide="+clientSide);
	    //System.out.println("serverSide="+serverSide);
	}
		
	
	//System.out.println("free="+java.lang.Runtime.getRuntime().freeMemory());
	//System.out.println("total="+java.lang.Runtime.getRuntime().totalMemory());
	//*********************************	
	//First phase - document processing
	//*********************************
	
	try {
 		WSDLFactory factory=WSDLFactory.newInstance();

		WSDLReader reader=factory.newWSDLReader();
		
		reader.setFeature ("javax.wsdl.verbose", debug);

		reader.setFeature ("javax.wsdl.importDocuments", true);

		def=reader.readWSDL(null,fileName);

    	        //if (debug)
		//	System.out.println("Def:"+def);
	
	
	//**********************************
	//Second phase - document navigation
 	//**********************************		 		
 	
 		//Please note: we consider 1 only port
 		//It is easy to generalize this code for more than 1 port	
		//	PortType portType=null;
		//    Binding bin=null;
		
		
		//PLEASE NOTE: if there is not a service definition, the generator switches
		//automatically to the "clientSide" mode
		//...in other words clientSide is set to true
		serv=def.getServices();
		serVal=serv.values();
		if (clientSide&&serVal.size()>0) {
			serverSide=true;
			clientSide=false;
		} 
		
		if (serVal.size()==0) {
			clientSide=true;
			if (debug) {
			    //		System.out.println("Not service definition present in the WSDL file...");
				//System.out.println("...so switch to clientSide generation mode.");
			}
		}
			if (!clientSide) {
			services=def.getServices();
			serviceQName=def.getQName();
			defName=serviceQName.getLocalPart();
			valuesServices=services.values();
			valuesServicesIterator=valuesServices.iterator();
	        	while (valuesServicesIterator.hasNext()) {
		 		service=(Service)valuesServicesIterator.next();
	 			ports=service.getPorts();
	 			valuesPorts=ports.values();
	 			valuesPortsIterator=valuesPorts.iterator();
	 			while (valuesPortsIterator.hasNext()) {
	 				port=(Port)valuesPortsIterator.next();
	 		        	serviceName=port.getName();
	 		        	serviceBinding=port.getBinding();	 			
	  			}
			}		
			//Retrieving binding operations
			bin =port.getBinding();
			bindingOperations=bin.getBindingOperations();	
			bindingOperationsNum=bindingOperations.size();
			bindingOperationsIterator=bindingOperations.iterator();
			while (bindingOperationsIterator.hasNext()) {
			    bindOp=(BindingOperation)bindingOperationsIterator.next();

 			bindingOperationsVector.add((BindingOperation)bindOp);
 			}

 			portType=bin.getPortType();
 		 }
 		 // end if (!clientSide)
 		
 		 			
 		
 		//Retrieving portTypes
 		
 		portTypes=null;
 		bindings=null;
 		//System.out.println("ClientSide = "+clientSide);		
 		if (clientSide) {

 			portTypes=def.getPortTypes();
	
 			portTypesValues=portTypes.values();

 			portTypesValuesIterator=portTypesValues.iterator();

 			while (portTypesValuesIterator.hasNext()) {

 				portType=(PortType) portTypesValuesIterator.next();
 			}
 			bindings=def.getBindings();
 			bindingsValues=bindings.values();
 			bindingsValuesIterator=bindingsValues.iterator();
 			while (bindingsValuesIterator.hasNext()) {
 				bin=(Binding) bindingsValuesIterator.next();
 			}
 			//to check
 			serviceBinding=bin;

 		}	
 		 		
        	//Retrieving operations
 	        portTypeName=portType.getQName().getLocalPart();
 	        //System.out.println("DEBUG: "+portTypeName);
 	        operations=portType.getOperations();
 	        operationsIterator=operations.iterator();
 	        
 	        operationsNum=operations.size();
 	         	        
 	        while (operationsIterator.hasNext()) {
 	        	op=(Operation)operationsIterator.next();
 	        	operationsVector.add((Operation)op);
 	        }
 	        
 	        //Structure containing operation data
 	        opData=new OperationData[operationsNum];
 	        opName=null;
 	        //Retrieving Messages and related info (exceptions, etc.)
 	        //
		//In other words, in this section we set the value of the opData array of OperationData objects
 	        //
 	        for (int i=0;i<operationsNum;i++) {
			opData[i]=new OperationData();
			opEl=(Operation) operationsVector.elementAt(i);
			
			if (!opEl.isUndefined()) {
				opName=new String (opEl.getName());
			}
			
			opData[i].setOperationName(opName);
			
			
	
			//Binding bind=null;
			//Map binds=def.getBindings();
			//System.out.println("DEBUG"+binds);
			//Collection bindsValues=binds.values();
			//System.out.println ("Bindings values number="+bindsValues.size());
			//Iterator bindsValuesIterator=bindsValues.iterator();
			//while (bindsValuesIterator.hasNext()) {
			//	bind=(Binding)bindsValuesIterator.next();
			//	
			//}
			
						
			bindOperation=serviceBinding.getBindingOperation(opEl.getName(),null,null);
			bindInput=bindOperation.getBindingInput();
			
			//if bindInput is null then exception, but before print this message...			
			if (bindInput==null) {
				System.err.println("Error: operation element without <input> declaration");
			}
			extList=bindInput.getExtensibilityElements();
			
			extListIterator=extList.iterator();
			while (extListIterator.hasNext()) {
				extElement=(ExtensibilityElement) extListIterator.next();
				if (extElement instanceof SOAPBody) {
					soapExtElement=(SOAPBody)extElement;
					opData[i].setOperationNameSpace(soapExtElement.getNamespaceURI());
				}
				//System.out.println("DEBUG SOAPExtensibility element"+extElement);
			
			}
			
								
			
			//opData[i].setOperationNameSpace(defName);
			
				
			inp=opEl.getInput();
			out=opEl.getOutput();
			
			int k=0;	
			//Retrieving parts of the request type message
			if (inp!=null) {
				//Retrieving request type message
				messageRequest=inp.getMessage();
				
				parameterOrderingList=opEl.getParameterOrdering();
				//get the parameter ordering for this operation
				requestMessageParts=messageRequest.getOrderedParts(parameterOrderingList);
				
				//Collection requestMessagePartsValues=requestMessageParts.values();
				
				requestMessagePartsIterator=requestMessageParts.iterator();
				requestMessagePartsNum=requestMessageParts.size();
				requestMessageParDataArray=new ParData[requestMessagePartsNum];
				while (requestMessagePartsIterator.hasNext()) {
					part=(Part)requestMessagePartsIterator.next();
					parData=new ParData();
			        	parData.setName(part.getName());
			        	typeQName=part.getTypeName();
			        	typeQNameLocalPart=typeQName.getLocalPart();
			        	typeQNameNameSpaceURI=typeQName.getNamespaceURI();
			        	parData.setType(typeQNameLocalPart);
			        	parData.setNameSpace(typeQNameNameSpaceURI);        
			        	requestMessageParDataArray[k]=new ParData();
					requestMessageParDataArray[k]=parData;
					k++;
				}
				opData[i].setParDataRequest(requestMessageParDataArray);      
			}//end if (in!=null)
			
			//Retrieving parts of the response type message
			if (out!=null) {	
				//Retrieving response type message
				messageResponse=out.getMessage();
				
				parameterOrderingList=opEl.getParameterOrdering();
				//get the parameter ordering for this operation
				responseMessageParts=messageResponse.getOrderedParts(parameterOrderingList);
				
				//Collection responseMessagePartsValues=responseMessageParts.values();
				responseMessagePartsIterator=responseMessageParts.iterator();
				responseMessagePartsNum=responseMessageParts.size();
				responseMessageParDataArray=new ParData[responseMessagePartsNum];
				k=0;
				while (responseMessagePartsIterator.hasNext()) {
					part=(Part)responseMessagePartsIterator.next();
			        	parData=new ParData();
			        	parData.setName(part.getName());
			        	typeQName=part.getTypeName();
			        	typeQNameLocalPart=typeQName.getLocalPart();
			        	typeQNameNameSpaceURI=typeQName.getNamespaceURI();
			        	parData.setType(typeQNameLocalPart);
			        	parData.setNameSpace(typeQNameNameSpaceURI);        
			        	responseMessageParDataArray[k]=new ParData();
					responseMessageParDataArray[k]=parData;
					k++;
				}
				opData[i].setParDataResponse(responseMessageParDataArray);  
			}//end if (out!=null)
			
			
			//Retrieving exception information
			faultMap=opEl.getFaults();
			faultValues=faultMap.values();
			faultValuesIterator=faultValues.iterator();
			
			FaultNumber=faultValues.size();
			excArr=new ExceptionData[FaultNumber];
			faultCounter=0;
			while (faultValuesIterator.hasNext()) {
				faultItem=(Fault) faultValuesIterator.next();
				relatedMessage=faultItem.getMessage();
				
				//PLEASE NOTE
				//according to JAX-RPC specification, we suppose that the name of the
				//Java exception is mapped from the *name* attribute of the WSDL *message*
				//corresponding to the WSDL *fault* element
				
				exceptionName=relatedMessage.getQName().getLocalPart();
				
				//PLEASE NOTE: we use the getOrderedParts to obtain an ordered list of parameters
				//Here the related javadoc documentation is reported
				//public java.util.List getOrderedParts(java.util.List partOrder)
				//Get an ordered list of parts as specified by the partOrder argument.
    				//Parameters:
        			//partOrder - a list of strings, with each string referring to a part by its name. If this argument is null, the parts are
        			//returned in the order in which they were added to the message.
				
				parList=null;
				relatedMessagePartsList=relatedMessage.getOrderedParts(parList);
				
				relatedMessagePartsIterator=relatedMessagePartsList.iterator();
				partNum=relatedMessagePartsList.size();
				excParArr=new ExceptionParData[partNum];
				partCounter=0;
				while (relatedMessagePartsIterator.hasNext()) {
					relatedMessagePartItem=(Part) relatedMessagePartsIterator.next();
					relatedMessagePartName=relatedMessagePartItem.getName();
					relatedMessagePartType_LocalPart=relatedMessagePartItem.getTypeName().getLocalPart();
					relatedMessagePartType_Namespace=relatedMessagePartItem.getTypeName().getNamespaceURI();	
					exceptionParDataItem=new ExceptionParData();
					exceptionParDataItem.setName(relatedMessagePartName);
					exceptionParDataItem.setType(relatedMessagePartType_LocalPart);
					exceptionParDataItem.setNameSpace(relatedMessagePartType_Namespace);	
					excParArr[partCounter]=exceptionParDataItem;
					
					//System.out.println("excParArr[partCounter].getName()"+excParArr[partCounter].getName());
					//System.out.println("excParArr[partCounter].getType()"+excParArr[partCounter].getType());
					//System.out.println("excParArr[partCounter].getNameSpace()"+excParArr[partCounter].getNameSpace());
					
					
										
					partCounter++;
				
				} //end while (relatedMessagePartsIterator.hasNext())
				
				excData=new ExceptionData();
				
				//	if (debug)
				//System.out.println("exception Name: "+exceptionName);
				
				excData.setName(exceptionName);
				excData.setExceptionParam(excParArr); 
				excArr[faultCounter]=excData;
				faultCounter++;
				
			}//end while (faultValuesIterator.hasNext())
			 		
			opData[i].setExceptions(excArr);		
					
		}
		
		//Retrieving Types
		//Using WSIF Schema Parser
		schemaParser=new org.apache.wsif.schema.Parser();
		schemaTypes=new Vector();
		def1=null;
		cl=this.getClass().getClassLoader();
		locWSIF=new WSIFWSDLLocatorImpl("",fileName,cl);
		//System.out.println("locWSIF:"+locWSIF);
		
		loc=(WSDLLocator)locWSIF;
		
		try {
			//System.out.println("schemaParser:"+schemaParser);
			schemaParser.getAllSchemaTypes(def,schemaTypes,null);

		}
		catch (org.apache.wsif.WSIFException e) {
			e.printStackTrace();
		}	
		if (schemaParser!=null) {
			schemaTypesList=(List)schemaTypes;
			schemaTypesIterator=schemaTypesList.iterator();
			s=0;
			typesData=new SchemaType[schemaTypesList.size()];
			while (schemaTypesIterator.hasNext()) {
				typesData[s]=(SchemaType)schemaTypesIterator.next();
				s++;	
			}
		}
		
					
		 			
	        //FOR DEBUGGING
	        
	        if (debug) {
		    //System.out.println  ("\nStarting code generation...");
	        	//Debugging service name
		    //System.out.println("\nService name: "+serviceName);
		    //	System.out.println ("___________________________");
			//Debugging binding operations
		    //
		    //System.out.println ("BINDING OPERATIONS");
 			for (int i=0;i<bindingOperationsNum;i++) {
 		        	BindingOperation bindingOperationElement=(BindingOperation) bindingOperationsVector.elementAt(i); 
 				//if (!bindingOperationElement.isUndefined())
				//		System.out.println (bindingOperationElement.getName());
 			}
			//System.out.println ("___________________________");
		
			//Debugging binding operations
			//	System.out.println ("OPERATIONS");
 			for (int i=0;i<operationsNum;i++) {
 				operationElement=(Operation) operationsVector.elementAt(i);
 				if (!operationElement.isUndefined())
 				System.out.println (operationElement.getName());
	 		}
			//	System.out.println ("___________________________");
		
			//Debugging param data
			//	System.out.println ("OPERATIONS PARAM");
			for (int i=0;i<operationsNum;i++) {
			    //	System.out.println("OperationName: "+opData[i].getOperationName());
				parRequest=opData[i].getParDataRequest();
				//	System.out.println ("Request Parameters");
				if (parRequest!=null)
					for (int k=0;k<parRequest.length;k++) {
					    //	System.out.println ("Name: "+parRequest[k].getName());
					    //	System.out.println ("Type: "+parRequest[k].getType());
					    //	System.out.println ("Namespace: "+parRequest[k].getNameSpace());
	               	 	}
	               	 	parResponse=opData[i].getParDataResponse();
				//	System.out.println ("Response Parameters");
	              	 	if (parResponse!=null)
	                		for (int k=0;k<parResponse.length;k++) {
					    //	System.out.println ("Name: "+parResponse[k].getName());
					    //	System.out.println ("Type: "+parResponse[k].getType());
					    //	System.out.println ("Namespace: "+parResponse[k].getNameSpace());               	
	                		}	
	     		}		
			//	System.out.println ("___________________________");
		
			//Debugging types data
			//	System.out.println ("TYPES");
			if (typesData!=null)
				for (int s=0;s<typesData.length;s++) {
				//	System.out.println("Typename: "+typesData[s].getTypeName().getLocalPart());
				}
		}//end if(debug)
		//END DEBUGGING
	  		  	
	      
	  	
	  	
	//*****************************************  		
	//Third phase - generation of the WSDD file
	//*****************************************
	
        //Creation of the directory for the interface file
        //it's the same of wsdd file...
	javaTypeDef=getJavaType(def.getQName());
        packageName=getPackageName(javaTypeDef);
        //defining interface directoryname
        interfaceDirName=new String(packageName);

        //Creation of the directory for generated files
        dir=new File(dirName+fileSeparator+interfaceDirName);
        
	//System.out.println("dir is = "+dirName+fileSeparator+interfaceDirName        );
        dir.mkdirs();        
             
                        
        try{  
                       
         if (!generateClientFilesOnly) {
          
           
            //Creation of the WSDD file
            fw=new FileWriter(dirName+fileSeparator+interfaceDirName+fileSeparator+"deploy.wsdd");
            
            //Generating initial comments 
            fw.write("\n <!-- Deployment file -->");
            fw.write("\n <!-- This file was auto-generated from WSDL file --> ");
            fw.write("\n <!-- using Generator class developed by Mirco Musolesi at INRIA Rocquencourt -->");
            fw.write("\n");
            
            fw.write("<wsdd>\n");
            fw.write("  <deployment xmlns="+'"'+"http://xml.apache.org/axis/wsdd/"+'"'+" ");
            fw.write("xmlns:java="+'"'+"http://xml.apache.org/axis/wsdd/providers/java"+'"'+">\n");
	    fw.write("\t<service name="+'"');
            fw.write(serviceName+'"'+" scope="+'"');
            fw.write(scope+'"'+" provider="+'"');
            fw.write("JAVA:RPC"+'"'+">");
            

            //definition of <parameter>
            fw.write("\n\t  <parameter name=");
            fw.write('"');
            fw.write("className");
            fw.write('"');
            fw.write(" value=");
            fw.write('"');
            fw.write(implClass);
            fw.write('"');
            fw.write("/>");

            //definition of <operation> 
            for (int k=0;k<operationsNum;k++) {
                    fw.write("\n\t\t<operation name="+'"');
                    initialLetterString=opData[k].getOperationName().substring(0,1);
                    lowerCaseInitialLetterString=initialLetterString.toLowerCase();
                    subString=opData[k].getOperationName().substring(1);
                    lowerCaseOperationName=lowerCaseInitialLetterString+subString;
                    //opName=lowerCaseOperationName;
                    /*
                    *	 PLEASE NOTE
                    * 	 We operate this conversion to mantain compability to Axis specification
                    */
                    fw.write(lowerCaseOperationName);//parameter name
                    fw.write('"'+" qname="+'"');
                    fw.write(prefixOperationQName+":"+opData[k].getOperationName());//parameter qname
                    fw.write('"');
                    fw.write(" xmlns:"+prefixOperationQName+"="+'"'+opData[k].getOperationNameSpace()+'"');
                    parRequest=opData[k].getParDataRequest();
                    parResponse=opData[k].getParDataResponse();
                    if (parResponse==null) {
                            fw.write(">");
                            if (parRequest!=null)
                                    for (int s=0;s<parRequest.length;s++) {
                                            fw.write("\n\t\t\t<parameter");
                                            fw.write(" name=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getName());
                                            fw.write('"');
                                            fw.write(" type=");
                                            fw.write('"');
                                            parPrefix=null;
                                            if (this.getPrefix(parRequest[s].getNameSpace())!=null)
                                                    parPrefix=this.getPrefix(parRequest[s].getNameSpace());
                                            else
                                                    parPrefix="tNS";
                                            fw.write(parPrefix);	
                                            fw.write(":");
                                            fw.write(parRequest[s].getType());
                                            fw.write('"');
                                            fw.write(" xmlns:");
                                            fw.write(parPrefix);
                                            fw.write("=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getNameSpace());
                                            fw.write('"');
                                            fw.write(" mode=");
                                            fw.write('"');
                                            fw.write("IN");
                                            fw.write('"');
                                            fw.write("/>");
                                    }

                    }
                    if (parResponse!=null)
                            if (parResponse.length==1) {
                                    fw.write(" returnQName=");
                                    fw.write('"');
                                    fw.write(parResponse[0].getName());
                                    fw.write('"');
                                    fw.write(" returnType=");
                                    fw.write('"');
                                    parPrefix=null;
                                    if (this.getPrefix(parResponse[0].getNameSpace())!=null)
                                            parPrefix=this.getPrefix(parResponse[0].getNameSpace());
                                    else
                                            parPrefix="rtNS";
                                    fw.write(parPrefix);
                                    fw.write(":");
                                    fw.write(parResponse[0].getType());
                                    fw.write('"');
                                    fw.write(" xmlns:");
                                    fw.write(parPrefix);
                                    fw.write("=");
                                    fw.write('"');
                                    fw.write(parResponse[0].getNameSpace());
                                    fw.write('"');
                                    fw.write(">");
                                    for (int s=0;s<parRequest.length;s++) {
                                            fw.write("\n\t\t\t<parameter");
                                            fw.write(" name=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getName());
                                            fw.write('"');
                                            fw.write(" type=");
                                            fw.write('"');
                                            parPrefix=null;
                                            if (this.getPrefix(parRequest[s].getNameSpace())!=null)
                                                    parPrefix=this.getPrefix(parRequest[s].getNameSpace());
                                            else
                                                    parPrefix="tNS";
                                            fw.write(parPrefix);
                                            fw.write(":");
                                            fw.write(parRequest[s].getType());
                                            fw.write('"');
                                            fw.write(" xmlns");
                                            fw.write(":");
                                            fw.write(parPrefix);
                                            fw.write("=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getNameSpace());
                                            fw.write('"');
                                            fw.write(" mode=");
                                            fw.write('"');
                                            fw.write("IN");
                                            fw.write('"');
                                            fw.write("/>");
                                    }
                                    //for (int s=0;s<parResponse.length;s++) {
                                    //	fw.write("\n\t\t\t<parameter");
                                    //	fw.write(" name=");
                                    //	fw.write('"');
                                    //	fw.write(parResponse[s].getName());
                                    //	fw.write('"');
                                    //	fw.write(" mode=");
                                    //	fw.write('"');
                                    //	fw.write("OUT");
                                    //	fw.write('"');
                                    //	fw.write("/>");
                                    //}
                    }
                    if (parResponse!=null)
                            if (parResponse.length>1) {
                                    fw.write(">");
                                    if (parRequest!=null)
                                            for (int s=0;s<parRequest.length;s++) {
                                                    fw.write("\n\t\t\t<parameter");
                                                    fw.write(" name=");
                                                    fw.write('"');
                                                    fw.write(parRequest[s].getName());
                                                    fw.write('"');
                                                    fw.write(" type=");
                                                    fw.write('"');
                                                    parPrefix=null;
                                                    if (this.getPrefix(parRequest[s].getNameSpace())!=null)
                                                            parPrefix=this.getPrefix(parRequest[s].getNameSpace());
                                                    else
                                                            parPrefix="tNS";
                                                    fw.write(parPrefix);
                                                    fw.write(":");
                                                    fw.write(parRequest[s].getType());
                                                    fw.write('"');
                                                    fw.write(" xmlns:");
                                                    fw.write(parPrefix);
                                                    fw.write("=");
                                                    fw.write('"');
                                                    fw.write(parRequest[s].getNameSpace());
                                                    fw.write('"');
                                                    fw.write(" mode=");
                                                    fw.write('"');
                                                    fw.write("IN");
                                                    fw.write('"');
                                                    fw.write("/>");
                                            }

                                            for (int s=0;s<parResponse.length;s++) {
                                                    fw.write("\n\t\t\t<parameter");
                                                    fw.write(" name=");
                                                    fw.write('"');
                                                    fw.write(parResponse[s].getName());
                                                    fw.write('"');
                                                    fw.write(" type=");
                                                    fw.write('"');
                                                    parPrefix=null;
                                                    if (this.getPrefix(parResponse[s].getNameSpace())!=null)
                                                            parPrefix=this.getPrefix(parResponse[s].getNameSpace());
                                                    else
                                                            parPrefix="rtNS";
                                                    fw.write(parPrefix);	
                                                    fw.write(":");
                                                    fw.write(parResponse[s].getType());
                                                    fw.write('"');
                                                    fw.write(" xmlns:");
                                                    fw.write(parPrefix);
                                                    fw.write("=");
                                                    fw.write('"');
                                                    fw.write(parResponse[s].getNameSpace());
                                                    fw.write('"');
                                                    fw.write(" mode=");
                                                    fw.write('"');
                                                    fw.write("OUT");
                                                    fw.write('"');
                                                    fw.write("/>");
                                            }

                            }	

                    exceptions=opData[k].getExceptions();
                    
                    for(int d=0; d<exceptions.length;d++) {
                        
                        exceptionName=exceptions[d].getName();
                        exceptionParam=exceptions[d].getExceptionParam();
                        
                        
                        fw.write("\n\t\t\t<!-- ");
                        
                        fw.write("<fault");
                        fw.write(" name=");
                        fw.write('"');
                        fw.write(exceptionName);
                        fw.write('"');
                        fw.write(" qname=");
                        fw.write('"');
                        fw.write(exceptionParam[0].getName());
                        fw.write('"');
                        fw.write(" class=");
                        fw.write('"');
                        faultClassJavaType=packageName+"."+firstLetterToUpperCase(exceptionName);
                        fw.write(faultClassJavaType);
                        fw.write('"');
                        fw.write(" type=");
                        fw.write('"');
                        fw.write("tns:");
                        fw.write(exceptionParam[0].getType());
                        fw.write('"');
                        fw.write(" xmlns:tns=");
                        fw.write('"');
                        fw.write(exceptionParam[0].getNameSpace());
                        fw.write('"');
                        fw.write("/>");
                                                
                        fw.write(" -->");
                    }
                    
                    
                    fw.write("\n\t\t</operation>");

            }


            //definition of <typeMapping>
            if (typesData!=null) 
            for (int k=0;k<typesData.length;k++) 
                if (!typesData[k].isArray()) {
                    
                    //_______________
                    //Case not array
                    //______________
                    
                    fw.write("\n\t\t<typeMapping");
                    fw.write(" xmlns:ns=");
                    fw.write('"');
                    fw.write(def.getTargetNamespace());
                    fw.write('"');
                    fw.write(" \n\t\t\t     qname=");
                    fw.write('"');
                    fw.write("ns:");
                    fw.write(typesData[k].getTypeName().getLocalPart());
                    fw.write('"');
                    fw.write(" \n\t\t\t     type=");
                    fw.write('"');
                    javaType=getJavaType(typesData[k].getTypeName());

                    fw.write(javaType);
                    fw.write('"');
                    fw.write(" \n\t\t\t     serializer=");
                    fw.write('"');
                    fw.write(serializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     deserializer=");
                    fw.write('"');
                    fw.write(deserializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     encodingStyle=");
                    fw.write('"');
                    fw.write(encodingStyle);
                    fw.write('"');
                    fw.write("/>");
                }// end if (!typesData[k].isArray())
                else {
                
                    //_______________
                    //Case array
                    //______________
                    
                    fw.write("\n\t\t<typeMapping");
                    fw.write(" xmlns:ns=");
                    fw.write('"');
                    fw.write(def.getTargetNamespace());
                    fw.write('"');
                    fw.write(" \n\t\t\t     qname=");
                    fw.write('"');
                    fw.write("ns:");
                    fw.write(typesData[k].getTypeName().getLocalPart());
                    fw.write('"');
                    fw.write(" \n\t\t\t     type=");
                    fw.write('"');

                    arrayTypeQName=typesData[k].getArrayType();
                    javaArrayTypeTemp=getJavaType(arrayTypeQName);
                    
                    javaArrayType=javaArrayTypeTemp+"[]";
                    //String javaArrayType=javaArrayTypeTemp;
                    
                    fw.write(javaArrayType);
                    fw.write('"');
                    fw.write(" \n\t\t\t     serializer=");
                    fw.write('"');
                    fw.write(arraySerializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     deserializer=");
                    fw.write('"');
                    fw.write(arrayDeserializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     encodingStyle=");
                    fw.write('"');
                    fw.write(encodingStyle);
                    fw.write('"');
                    fw.write("/>");
                
                
                
                }//end else
                    


            //closing all...
            fw.write("\n\t</service>");
            fw.write("\n  </deployment>\n");
            fw.write("</wsdd>");
            fw.close();
		}
	}
	catch (Exception e) {
		e.printStackTrace();
	}
	//********************************************
        //11th phase: creation of a generation report
        //********************************************
       
	try {		
			
		//Creating a generation report
		if (debug) {
		    //System.out.println("Generation summary:");
			//wsdd file generation report
		    //if (!generateClientFilesOnly)
				System.out.println("The file "+dirName+fileSeparator+interfaceDirName+fileSeparator+"deploy.wsdd"+" has been created.");
			//System.out.println("\n\n*************************************************************");
	   		System.out.println("\n");
				
		}
		//Generation ok...so
		return true;
	
	}
	catch (Exception e) {
		if (debug) {
			e.printStackTrace();
			//System.out.println("Generation summary:\n");
			//System.out.println("Error during the generation process.");
			//System.out.println("\n\n*************************************************************");
		}
		return false;
	}
	
	
	 
        }// end try
	catch (WSDLException e) {
		e.printStackTrace();
		return false;
	}


 }

}//end class Generator
